/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Font } from 'devextreme/common/charts';
import { Format } from 'devextreme/common/core/localization';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoBarGaugeLabelComponent extends NestedOption implements OnDestroy, OnInit {
    get connectorColor(): string | undefined;
    set connectorColor(value: string | undefined);
    get connectorWidth(): number;
    set connectorWidth(value: number);
    get customizeText(): ((barValue: {
        value: number;
        valueText: string;
    }) => string);
    set customizeText(value: ((barValue: {
        value: number;
        valueText: string;
    }) => string));
    get font(): Font;
    set font(value: Font);
    get format(): Format | undefined;
    set format(value: Format | undefined);
    get indent(): number;
    set indent(value: number);
    get visible(): boolean;
    set visible(value: boolean);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoBarGaugeLabelComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoBarGaugeLabelComponent, "dxo-bar-gauge-label", never, { "connectorColor": { "alias": "connectorColor"; "required": false; }; "connectorWidth": { "alias": "connectorWidth"; "required": false; }; "customizeText": { "alias": "customizeText"; "required": false; }; "font": { "alias": "font"; "required": false; }; "format": { "alias": "format"; "required": false; }; "indent": { "alias": "indent"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoBarGaugeLabelModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoBarGaugeLabelModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoBarGaugeLabelModule, [typeof DxoBarGaugeLabelComponent], never, [typeof DxoBarGaugeLabelComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoBarGaugeLabelModule>;
}
