/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { chartPointAggregationInfoObject, chartSeriesObject, ChartSeriesAggregationMethod } from 'devextreme/viz/chart';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoChartAggregationComponent extends NestedOption implements OnDestroy, OnInit {
    get calculate(): ((aggregationInfo: chartPointAggregationInfoObject, series: chartSeriesObject) => Record<string, any> | Array<Record<string, any>>) | undefined;
    set calculate(value: ((aggregationInfo: chartPointAggregationInfoObject, series: chartSeriesObject) => Record<string, any> | Array<Record<string, any>>) | undefined);
    get enabled(): boolean;
    set enabled(value: boolean);
    get method(): ChartSeriesAggregationMethod;
    set method(value: ChartSeriesAggregationMethod);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoChartAggregationComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoChartAggregationComponent, "dxo-chart-aggregation", never, { "calculate": { "alias": "calculate"; "required": false; }; "enabled": { "alias": "enabled"; "required": false; }; "method": { "alias": "method"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoChartAggregationModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoChartAggregationModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoChartAggregationModule, [typeof DxoChartAggregationComponent], never, [typeof DxoChartAggregationComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoChartAggregationModule>;
}
