/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { AnimationEaseMode } from 'devextreme/common/charts';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoChartAnimationComponent extends NestedOption implements OnDestroy, OnInit {
    get duration(): number;
    set duration(value: number);
    get easing(): AnimationEaseMode;
    set easing(value: AnimationEaseMode);
    get enabled(): boolean;
    set enabled(value: boolean);
    get maxPointCountSupported(): number;
    set maxPointCountSupported(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoChartAnimationComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoChartAnimationComponent, "dxo-chart-animation", never, { "duration": { "alias": "duration"; "required": false; }; "easing": { "alias": "easing"; "required": false; }; "enabled": { "alias": "enabled"; "required": false; }; "maxPointCountSupported": { "alias": "maxPointCountSupported"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoChartAnimationModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoChartAnimationModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoChartAnimationModule, [typeof DxoChartAnimationComponent], never, [typeof DxoChartAnimationComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoChartAnimationModule>;
}
