/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { DashStyle, Font, RelativePosition } from 'devextreme/common/charts';
import { HorizontalAlignment, VerticalAlignment } from 'devextreme/common';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoChartAxisConstantLineStyleComponent extends NestedOption implements OnDestroy, OnInit {
    get color(): string;
    set color(value: string);
    get dashStyle(): DashStyle;
    set dashStyle(value: DashStyle);
    get label(): {
        font?: Font;
        horizontalAlignment?: HorizontalAlignment;
        position?: RelativePosition;
        verticalAlignment?: VerticalAlignment;
        visible?: boolean;
    };
    set label(value: {
        font?: Font;
        horizontalAlignment?: HorizontalAlignment;
        position?: RelativePosition;
        verticalAlignment?: VerticalAlignment;
        visible?: boolean;
    });
    get paddingLeftRight(): number;
    set paddingLeftRight(value: number);
    get paddingTopBottom(): number;
    set paddingTopBottom(value: number);
    get width(): number;
    set width(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoChartAxisConstantLineStyleComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoChartAxisConstantLineStyleComponent, "dxo-chart-axis-constant-line-style", never, { "color": { "alias": "color"; "required": false; }; "dashStyle": { "alias": "dashStyle"; "required": false; }; "label": { "alias": "label"; "required": false; }; "paddingLeftRight": { "alias": "paddingLeftRight"; "required": false; }; "paddingTopBottom": { "alias": "paddingTopBottom"; "required": false; }; "width": { "alias": "width"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoChartAxisConstantLineStyleModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoChartAxisConstantLineStyleModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoChartAxisConstantLineStyleModule, [typeof DxoChartAxisConstantLineStyleComponent], never, [typeof DxoChartAxisConstantLineStyleComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoChartAxisConstantLineStyleModule>;
}
