/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { HorizontalAlignment } from 'devextreme/common';
import { Font, TextOverflow, WordWrap } from 'devextreme/common/charts';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoChartAxisTitleComponent extends NestedOption implements OnDestroy, OnInit {
    get alignment(): HorizontalAlignment;
    set alignment(value: HorizontalAlignment);
    get font(): Font;
    set font(value: Font);
    get margin(): number;
    set margin(value: number);
    get text(): string | undefined;
    set text(value: string | undefined);
    get textOverflow(): TextOverflow;
    set textOverflow(value: TextOverflow);
    get wordWrap(): WordWrap;
    set wordWrap(value: WordWrap);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoChartAxisTitleComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoChartAxisTitleComponent, "dxo-chart-axis-title", never, { "alignment": { "alias": "alignment"; "required": false; }; "font": { "alias": "font"; "required": false; }; "margin": { "alias": "margin"; "required": false; }; "text": { "alias": "text"; "required": false; }; "textOverflow": { "alias": "textOverflow"; "required": false; }; "wordWrap": { "alias": "wordWrap"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoChartAxisTitleModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoChartAxisTitleModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoChartAxisTitleModule, [typeof DxoChartAxisTitleComponent], never, [typeof DxoChartAxisTitleComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoChartAxisTitleModule>;
}
