/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { chartPointObject } from 'devextreme/viz/chart';
import { Font } from 'devextreme/common/charts';
import { Format } from 'devextreme/common/core/localization';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoChartHorizontalLineLabelComponent extends NestedOption implements OnDestroy, OnInit {
    get backgroundColor(): string;
    set backgroundColor(value: string);
    get customizeText(): ((info: {
        point: chartPointObject;
        value: Date | number | string;
        valueText: string;
    }) => string);
    set customizeText(value: ((info: {
        point: chartPointObject;
        value: Date | number | string;
        valueText: string;
    }) => string));
    get font(): Font;
    set font(value: Font);
    get format(): Format | undefined;
    set format(value: Format | undefined);
    get visible(): boolean;
    set visible(value: boolean);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoChartHorizontalLineLabelComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoChartHorizontalLineLabelComponent, "dxo-chart-horizontal-line-label", never, { "backgroundColor": { "alias": "backgroundColor"; "required": false; }; "customizeText": { "alias": "customizeText"; "required": false; }; "font": { "alias": "font"; "required": false; }; "format": { "alias": "format"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoChartHorizontalLineLabelModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoChartHorizontalLineLabelModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoChartHorizontalLineLabelModule, [typeof DxoChartHorizontalLineLabelComponent], never, [typeof DxoChartHorizontalLineLabelComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoChartHorizontalLineLabelModule>;
}
