/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { ChartsColor, Palette, PaletteExtensionMode } from 'devextreme/common/charts';
import { CircularGaugeElementOrientation } from 'devextreme/viz/circular_gauge';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiCircularGaugeRangeComponent } from './range-dxi';
import * as i0 from "@angular/core";
export declare class DxoCircularGaugeRangeContainerComponent extends NestedOption implements OnDestroy, OnInit {
    get backgroundColor(): ChartsColor | string;
    set backgroundColor(value: ChartsColor | string);
    get offset(): number;
    set offset(value: number);
    get orientation(): CircularGaugeElementOrientation;
    set orientation(value: CircularGaugeElementOrientation);
    get palette(): Array<string> | Palette;
    set palette(value: Array<string> | Palette);
    get paletteExtensionMode(): PaletteExtensionMode;
    set paletteExtensionMode(value: PaletteExtensionMode);
    get ranges(): {
        color?: ChartsColor | string;
        endValue?: number;
        startValue?: number;
    }[];
    set ranges(value: {
        color?: ChartsColor | string;
        endValue?: number;
        startValue?: number;
    }[]);
    get width(): number;
    set width(value: number);
    protected get _optionPath(): string;
    get rangesChildren(): QueryList<DxiCircularGaugeRangeComponent>;
    set rangesChildren(value: QueryList<DxiCircularGaugeRangeComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoCircularGaugeRangeContainerComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoCircularGaugeRangeContainerComponent, "dxo-circular-gauge-range-container", never, { "backgroundColor": { "alias": "backgroundColor"; "required": false; }; "offset": { "alias": "offset"; "required": false; }; "orientation": { "alias": "orientation"; "required": false; }; "palette": { "alias": "palette"; "required": false; }; "paletteExtensionMode": { "alias": "paletteExtensionMode"; "required": false; }; "ranges": { "alias": "ranges"; "required": false; }; "width": { "alias": "width"; "required": false; }; }, {}, ["rangesChildren"], never, false, never>;
}
export declare class DxoCircularGaugeRangeContainerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoCircularGaugeRangeContainerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoCircularGaugeRangeContainerModule, [typeof DxoCircularGaugeRangeContainerComponent], never, [typeof DxoCircularGaugeRangeContainerComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoCircularGaugeRangeContainerModule>;
}
