/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { SingleMultipleOrNone, SelectAllMode } from 'devextreme/common';
import { SelectionSensitivity } from 'devextreme/ui/data_grid';
import { SelectionColumnDisplayMode } from 'devextreme/common/grids';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDataGridDataGridSelectionComponent extends NestedOption implements OnDestroy, OnInit {
    get allowSelectAll(): boolean;
    set allowSelectAll(value: boolean);
    get deferred(): boolean;
    set deferred(value: boolean);
    get mode(): SingleMultipleOrNone;
    set mode(value: SingleMultipleOrNone);
    get selectAllMode(): SelectAllMode;
    set selectAllMode(value: SelectAllMode);
    get sensitivity(): SelectionSensitivity;
    set sensitivity(value: SelectionSensitivity);
    get showCheckBoxesMode(): SelectionColumnDisplayMode;
    set showCheckBoxesMode(value: SelectionColumnDisplayMode);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridDataGridSelectionComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataGridDataGridSelectionComponent, "dxo-data-grid-data-grid-selection", never, { "allowSelectAll": { "alias": "allowSelectAll"; "required": false; }; "deferred": { "alias": "deferred"; "required": false; }; "mode": { "alias": "mode"; "required": false; }; "selectAllMode": { "alias": "selectAllMode"; "required": false; }; "sensitivity": { "alias": "sensitivity"; "required": false; }; "showCheckBoxesMode": { "alias": "showCheckBoxesMode"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDataGridDataGridSelectionModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridDataGridSelectionModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataGridDataGridSelectionModule, [typeof DxoDataGridDataGridSelectionComponent], never, [typeof DxoDataGridDataGridSelectionComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataGridDataGridSelectionModule>;
}
