/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { DataGridExportFormat } from 'devextreme/ui/data_grid';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDataGridExportComponent extends NestedOption implements OnDestroy, OnInit {
    get allowExportSelectedData(): boolean;
    set allowExportSelectedData(value: boolean);
    get enabled(): boolean;
    set enabled(value: boolean);
    get formats(): Array<DataGridExportFormat | string>;
    set formats(value: Array<DataGridExportFormat | string>);
    get texts(): {
        exportAll?: string;
        exportSelectedRows?: string;
        exportTo?: string;
    };
    set texts(value: {
        exportAll?: string;
        exportSelectedRows?: string;
        exportTo?: string;
    });
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridExportComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataGridExportComponent, "dxo-data-grid-export", never, { "allowExportSelectedData": { "alias": "allowExportSelectedData"; "required": false; }; "enabled": { "alias": "enabled"; "required": false; }; "formats": { "alias": "formats"; "required": false; }; "texts": { "alias": "texts"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDataGridExportModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridExportModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataGridExportModule, [typeof DxoDataGridExportComponent], never, [typeof DxoDataGridExportComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataGridExportModule>;
}
