/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, ElementRef, Renderer2, AfterViewInit, QueryList } from '@angular/core';
import * as CommonTypes from 'devextreme/common';
import { FormItemComponent, FormItemType, LabelLocation } from 'devextreme/ui/form';
import { HorizontalAlignment } from 'devextreme/common';
import { NestedOptionHost, DxTemplateDirective, IDxTemplateHost, DxTemplateHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiDataGridAsyncRuleComponent } from './async-rule-dxi';
import { DxiDataGridCompareRuleComponent } from './compare-rule-dxi';
import { DxiDataGridCustomRuleComponent } from './custom-rule-dxi';
import { DxiDataGridEmailRuleComponent } from './email-rule-dxi';
import { DxiDataGridNumericRuleComponent } from './numeric-rule-dxi';
import { DxiDataGridPatternRuleComponent } from './pattern-rule-dxi';
import { DxiDataGridRangeRuleComponent } from './range-rule-dxi';
import { DxiDataGridRequiredRuleComponent } from './required-rule-dxi';
import { DxiDataGridStringLengthRuleComponent } from './string-length-rule-dxi';
import { DxiDataGridValidationRuleComponent } from './validation-rule-dxi';
import * as i0 from "@angular/core";
export declare class DxoDataGridFormItemComponent extends NestedOption implements AfterViewInit, OnDestroy, OnInit, IDxTemplateHost {
    private renderer;
    private document;
    private element;
    get colSpan(): number | undefined;
    set colSpan(value: number | undefined);
    get cssClass(): string | undefined;
    set cssClass(value: string | undefined);
    get dataField(): string | undefined;
    set dataField(value: string | undefined);
    get editorOptions(): any | undefined;
    set editorOptions(value: any | undefined);
    get editorType(): FormItemComponent;
    set editorType(value: FormItemComponent);
    get helpText(): string | undefined;
    set helpText(value: string | undefined);
    get isRequired(): boolean | undefined;
    set isRequired(value: boolean | undefined);
    get itemType(): FormItemType;
    set itemType(value: FormItemType);
    get label(): {
        alignment?: HorizontalAlignment;
        location?: LabelLocation;
        showColon?: boolean;
        template?: any;
        text?: string | undefined;
        visible?: boolean;
    };
    set label(value: {
        alignment?: HorizontalAlignment;
        location?: LabelLocation;
        showColon?: boolean;
        template?: any;
        text?: string | undefined;
        visible?: boolean;
    });
    get name(): string | undefined;
    set name(value: string | undefined);
    get template(): any;
    set template(value: any);
    get validationRules(): Array<CommonTypes.ValidationRule>;
    set validationRules(value: Array<CommonTypes.ValidationRule>);
    get visible(): boolean;
    set visible(value: boolean);
    get visibleIndex(): number | undefined;
    set visibleIndex(value: number | undefined);
    protected get _optionPath(): string;
    get asyncRulesChildren(): QueryList<DxiDataGridAsyncRuleComponent>;
    set asyncRulesChildren(value: QueryList<DxiDataGridAsyncRuleComponent>);
    get compareRulesChildren(): QueryList<DxiDataGridCompareRuleComponent>;
    set compareRulesChildren(value: QueryList<DxiDataGridCompareRuleComponent>);
    get customRulesChildren(): QueryList<DxiDataGridCustomRuleComponent>;
    set customRulesChildren(value: QueryList<DxiDataGridCustomRuleComponent>);
    get emailRulesChildren(): QueryList<DxiDataGridEmailRuleComponent>;
    set emailRulesChildren(value: QueryList<DxiDataGridEmailRuleComponent>);
    get numericRulesChildren(): QueryList<DxiDataGridNumericRuleComponent>;
    set numericRulesChildren(value: QueryList<DxiDataGridNumericRuleComponent>);
    get patternRulesChildren(): QueryList<DxiDataGridPatternRuleComponent>;
    set patternRulesChildren(value: QueryList<DxiDataGridPatternRuleComponent>);
    get rangeRulesChildren(): QueryList<DxiDataGridRangeRuleComponent>;
    set rangeRulesChildren(value: QueryList<DxiDataGridRangeRuleComponent>);
    get requiredRulesChildren(): QueryList<DxiDataGridRequiredRuleComponent>;
    set requiredRulesChildren(value: QueryList<DxiDataGridRequiredRuleComponent>);
    get stringLengthRulesChildren(): QueryList<DxiDataGridStringLengthRuleComponent>;
    set stringLengthRulesChildren(value: QueryList<DxiDataGridStringLengthRuleComponent>);
    get validationRulesChildren(): QueryList<DxiDataGridValidationRuleComponent>;
    set validationRulesChildren(value: QueryList<DxiDataGridValidationRuleComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost, renderer: Renderer2, document: any, templateHost: DxTemplateHost, element: ElementRef);
    setTemplate(template: DxTemplateDirective): void;
    ngAfterViewInit(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridFormItemComponent, [{ host: true; skipSelf: true; }, { host: true; }, null, null, { host: true; }, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataGridFormItemComponent, "dxo-data-grid-form-item", never, { "colSpan": { "alias": "colSpan"; "required": false; }; "cssClass": { "alias": "cssClass"; "required": false; }; "dataField": { "alias": "dataField"; "required": false; }; "editorOptions": { "alias": "editorOptions"; "required": false; }; "editorType": { "alias": "editorType"; "required": false; }; "helpText": { "alias": "helpText"; "required": false; }; "isRequired": { "alias": "isRequired"; "required": false; }; "itemType": { "alias": "itemType"; "required": false; }; "label": { "alias": "label"; "required": false; }; "name": { "alias": "name"; "required": false; }; "template": { "alias": "template"; "required": false; }; "validationRules": { "alias": "validationRules"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; "visibleIndex": { "alias": "visibleIndex"; "required": false; }; }, {}, ["asyncRulesChildren", "compareRulesChildren", "customRulesChildren", "emailRulesChildren", "numericRulesChildren", "patternRulesChildren", "rangeRulesChildren", "requiredRulesChildren", "stringLengthRulesChildren", "validationRulesChildren"], ["*"], false, never>;
}
export declare class DxoDataGridFormItemModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridFormItemModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataGridFormItemModule, [typeof DxoDataGridFormItemComponent], never, [typeof DxoDataGridFormItemComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataGridFormItemModule>;
}
