/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { GroupExpandMode } from 'devextreme/common/grids';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDataGridGroupingComponent extends NestedOption implements OnDestroy, OnInit {
    get allowCollapsing(): boolean;
    set allowCollapsing(value: boolean);
    get autoExpandAll(): boolean;
    set autoExpandAll(value: boolean);
    get contextMenuEnabled(): boolean;
    set contextMenuEnabled(value: boolean);
    get expandMode(): GroupExpandMode;
    set expandMode(value: GroupExpandMode);
    get texts(): {
        groupByThisColumn?: string;
        groupContinuedMessage?: string;
        groupContinuesMessage?: string;
        ungroup?: string;
        ungroupAll?: string;
    };
    set texts(value: {
        groupByThisColumn?: string;
        groupContinuedMessage?: string;
        groupContinuesMessage?: string;
        ungroup?: string;
        ungroupAll?: string;
    });
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridGroupingComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataGridGroupingComponent, "dxo-data-grid-grouping", never, { "allowCollapsing": { "alias": "allowCollapsing"; "required": false; }; "autoExpandAll": { "alias": "autoExpandAll"; "required": false; }; "contextMenuEnabled": { "alias": "contextMenuEnabled"; "required": false; }; "expandMode": { "alias": "expandMode"; "required": false; }; "texts": { "alias": "texts"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDataGridGroupingModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridGroupingModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataGridGroupingModule, [typeof DxoDataGridGroupingComponent], never, [typeof DxoDataGridGroupingComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataGridGroupingModule>;
}
