/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { PagerPageSize } from 'devextreme/common/grids';
import { Mode, DisplayMode } from 'devextreme/common';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDataGridPagerComponent extends NestedOption implements OnDestroy, OnInit {
    get allowedPageSizes(): Array<number | PagerPageSize> | Mode;
    set allowedPageSizes(value: Array<number | PagerPageSize> | Mode);
    get displayMode(): DisplayMode;
    set displayMode(value: DisplayMode);
    get infoText(): string;
    set infoText(value: string);
    get label(): string;
    set label(value: string);
    get showInfo(): boolean;
    set showInfo(value: boolean);
    get showNavigationButtons(): boolean;
    set showNavigationButtons(value: boolean);
    get showPageSizeSelector(): boolean;
    set showPageSizeSelector(value: boolean);
    get visible(): boolean | Mode;
    set visible(value: boolean | Mode);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridPagerComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataGridPagerComponent, "dxo-data-grid-pager", never, { "allowedPageSizes": { "alias": "allowedPageSizes"; "required": false; }; "displayMode": { "alias": "displayMode"; "required": false; }; "infoText": { "alias": "infoText"; "required": false; }; "label": { "alias": "label"; "required": false; }; "showInfo": { "alias": "showInfo"; "required": false; }; "showNavigationButtons": { "alias": "showNavigationButtons"; "required": false; }; "showPageSizeSelector": { "alias": "showPageSizeSelector"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDataGridPagerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridPagerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataGridPagerModule, [typeof DxoDataGridPagerComponent], never, [typeof DxoDataGridPagerComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataGridPagerModule>;
}
