/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { DataRenderMode } from 'devextreme/common/grids';
import { DataGridScrollMode } from 'devextreme/ui/data_grid';
import { ScrollbarMode, Mode } from 'devextreme/common';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDataGridScrollingComponent extends NestedOption implements OnDestroy, OnInit {
    get columnRenderingMode(): DataRenderMode;
    set columnRenderingMode(value: DataRenderMode);
    get mode(): DataGridScrollMode;
    set mode(value: DataGridScrollMode);
    get preloadEnabled(): boolean;
    set preloadEnabled(value: boolean);
    get renderAsync(): boolean | undefined;
    set renderAsync(value: boolean | undefined);
    get rowRenderingMode(): DataRenderMode;
    set rowRenderingMode(value: DataRenderMode);
    get scrollByContent(): boolean;
    set scrollByContent(value: boolean);
    get scrollByThumb(): boolean;
    set scrollByThumb(value: boolean);
    get showScrollbar(): ScrollbarMode;
    set showScrollbar(value: ScrollbarMode);
    get useNative(): boolean | Mode;
    set useNative(value: boolean | Mode);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridScrollingComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataGridScrollingComponent, "dxo-data-grid-scrolling", never, { "columnRenderingMode": { "alias": "columnRenderingMode"; "required": false; }; "mode": { "alias": "mode"; "required": false; }; "preloadEnabled": { "alias": "preloadEnabled"; "required": false; }; "renderAsync": { "alias": "renderAsync"; "required": false; }; "rowRenderingMode": { "alias": "rowRenderingMode"; "required": false; }; "scrollByContent": { "alias": "scrollByContent"; "required": false; }; "scrollByThumb": { "alias": "scrollByThumb"; "required": false; }; "showScrollbar": { "alias": "showScrollbar"; "required": false; }; "useNative": { "alias": "useNative"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDataGridScrollingModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridScrollingModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataGridScrollingModule, [typeof DxoDataGridScrollingComponent], never, [typeof DxoDataGridScrollingComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataGridScrollingModule>;
}
