/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, EventEmitter } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDataGridSearchPanelComponent extends NestedOption implements OnDestroy, OnInit {
    get highlightCaseSensitive(): boolean;
    set highlightCaseSensitive(value: boolean);
    get highlightSearchText(): boolean;
    set highlightSearchText(value: boolean);
    get placeholder(): string;
    set placeholder(value: string);
    get searchVisibleColumnsOnly(): boolean;
    set searchVisibleColumnsOnly(value: boolean);
    get text(): string;
    set text(value: string);
    get visible(): boolean;
    set visible(value: boolean);
    get width(): number | string;
    set width(value: number | string);
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    textChange: EventEmitter<string>;
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridSearchPanelComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataGridSearchPanelComponent, "dxo-data-grid-search-panel", never, { "highlightCaseSensitive": { "alias": "highlightCaseSensitive"; "required": false; }; "highlightSearchText": { "alias": "highlightSearchText"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "searchVisibleColumnsOnly": { "alias": "searchVisibleColumnsOnly"; "required": false; }; "text": { "alias": "text"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; "width": { "alias": "width"; "required": false; }; }, { "textChange": "textChange"; }, never, never, false, never>;
}
export declare class DxoDataGridSearchPanelModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridSearchPanelModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataGridSearchPanelModule, [typeof DxoDataGridSearchPanelComponent], never, [typeof DxoDataGridSearchPanelComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataGridSearchPanelModule>;
}
