/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDataGridTextsComponent extends NestedOption implements OnDestroy, OnInit {
    get addRow(): string;
    set addRow(value: string);
    get cancelAllChanges(): string;
    set cancelAllChanges(value: string);
    get cancelRowChanges(): string;
    set cancelRowChanges(value: string);
    get confirmDeleteMessage(): string;
    set confirmDeleteMessage(value: string);
    get confirmDeleteTitle(): string;
    set confirmDeleteTitle(value: string);
    get deleteRow(): string;
    set deleteRow(value: string);
    get editRow(): string;
    set editRow(value: string);
    get saveAllChanges(): string;
    set saveAllChanges(value: string);
    get saveRowChanges(): string;
    set saveRowChanges(value: string);
    get undeleteRow(): string;
    set undeleteRow(value: string);
    get validationCancelChanges(): string;
    set validationCancelChanges(value: string);
    get exportAll(): string;
    set exportAll(value: string);
    get exportSelectedRows(): string;
    set exportSelectedRows(value: string);
    get exportTo(): string;
    set exportTo(value: string);
    get groupByThisColumn(): string;
    set groupByThisColumn(value: string);
    get groupContinuedMessage(): string;
    set groupContinuedMessage(value: string);
    get groupContinuesMessage(): string;
    set groupContinuesMessage(value: string);
    get ungroup(): string;
    set ungroup(value: string);
    get ungroupAll(): string;
    set ungroupAll(value: string);
    get avg(): string;
    set avg(value: string);
    get avgOtherColumn(): string;
    set avgOtherColumn(value: string);
    get count(): string;
    set count(value: string);
    get max(): string;
    set max(value: string);
    get maxOtherColumn(): string;
    set maxOtherColumn(value: string);
    get min(): string;
    set min(value: string);
    get minOtherColumn(): string;
    set minOtherColumn(value: string);
    get sum(): string;
    set sum(value: string);
    get sumOtherColumn(): string;
    set sumOtherColumn(value: string);
    get fix(): string;
    set fix(value: string);
    get leftPosition(): string;
    set leftPosition(value: string);
    get rightPosition(): string;
    set rightPosition(value: string);
    get stickyPosition(): string;
    set stickyPosition(value: string);
    get unfix(): string;
    set unfix(value: string);
    get clearFilter(): string;
    set clearFilter(value: string);
    get createFilter(): string;
    set createFilter(value: string);
    get filterEnabledHint(): string;
    set filterEnabledHint(value: string);
    get cancel(): string;
    set cancel(value: string);
    get emptyValue(): string;
    set emptyValue(value: string);
    get ok(): string;
    set ok(value: string);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridTextsComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataGridTextsComponent, "dxo-data-grid-texts", never, { "addRow": { "alias": "addRow"; "required": false; }; "cancelAllChanges": { "alias": "cancelAllChanges"; "required": false; }; "cancelRowChanges": { "alias": "cancelRowChanges"; "required": false; }; "confirmDeleteMessage": { "alias": "confirmDeleteMessage"; "required": false; }; "confirmDeleteTitle": { "alias": "confirmDeleteTitle"; "required": false; }; "deleteRow": { "alias": "deleteRow"; "required": false; }; "editRow": { "alias": "editRow"; "required": false; }; "saveAllChanges": { "alias": "saveAllChanges"; "required": false; }; "saveRowChanges": { "alias": "saveRowChanges"; "required": false; }; "undeleteRow": { "alias": "undeleteRow"; "required": false; }; "validationCancelChanges": { "alias": "validationCancelChanges"; "required": false; }; "exportAll": { "alias": "exportAll"; "required": false; }; "exportSelectedRows": { "alias": "exportSelectedRows"; "required": false; }; "exportTo": { "alias": "exportTo"; "required": false; }; "groupByThisColumn": { "alias": "groupByThisColumn"; "required": false; }; "groupContinuedMessage": { "alias": "groupContinuedMessage"; "required": false; }; "groupContinuesMessage": { "alias": "groupContinuesMessage"; "required": false; }; "ungroup": { "alias": "ungroup"; "required": false; }; "ungroupAll": { "alias": "ungroupAll"; "required": false; }; "avg": { "alias": "avg"; "required": false; }; "avgOtherColumn": { "alias": "avgOtherColumn"; "required": false; }; "count": { "alias": "count"; "required": false; }; "max": { "alias": "max"; "required": false; }; "maxOtherColumn": { "alias": "maxOtherColumn"; "required": false; }; "min": { "alias": "min"; "required": false; }; "minOtherColumn": { "alias": "minOtherColumn"; "required": false; }; "sum": { "alias": "sum"; "required": false; }; "sumOtherColumn": { "alias": "sumOtherColumn"; "required": false; }; "fix": { "alias": "fix"; "required": false; }; "leftPosition": { "alias": "leftPosition"; "required": false; }; "rightPosition": { "alias": "rightPosition"; "required": false; }; "stickyPosition": { "alias": "stickyPosition"; "required": false; }; "unfix": { "alias": "unfix"; "required": false; }; "clearFilter": { "alias": "clearFilter"; "required": false; }; "createFilter": { "alias": "createFilter"; "required": false; }; "filterEnabledHint": { "alias": "filterEnabledHint"; "required": false; }; "cancel": { "alias": "cancel"; "required": false; }; "emptyValue": { "alias": "emptyValue"; "required": false; }; "ok": { "alias": "ok"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDataGridTextsModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridTextsModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataGridTextsModule, [typeof DxoDataGridTextsComponent], never, [typeof DxoDataGridTextsComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataGridTextsModule>;
}
