/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { DataGridPredefinedToolbarItem, dxDataGridToolbarItem } from 'devextreme/ui/data_grid';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiDataGridItemComponent } from './item-dxi';
import * as i0 from "@angular/core";
export declare class DxoDataGridToolbarComponent extends NestedOption implements OnDestroy, OnInit {
    get disabled(): boolean;
    set disabled(value: boolean);
    get items(): Array<DataGridPredefinedToolbarItem | dxDataGridToolbarItem>;
    set items(value: Array<DataGridPredefinedToolbarItem | dxDataGridToolbarItem>);
    get visible(): boolean | undefined;
    set visible(value: boolean | undefined);
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiDataGridItemComponent>;
    set itemsChildren(value: QueryList<DxiDataGridItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridToolbarComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDataGridToolbarComponent, "dxo-data-grid-toolbar", never, { "disabled": { "alias": "disabled"; "required": false; }; "items": { "alias": "items"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; }, {}, ["itemsChildren"], never, false, never>;
}
export declare class DxoDataGridToolbarModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDataGridToolbarModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDataGridToolbarModule, [typeof DxoDataGridToolbarComponent], never, [typeof DxoDataGridToolbarComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDataGridToolbarModule>;
}
