/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { QueryList } from '@angular/core';
import { Command, CustomCommand } from 'devextreme/ui/diagram';
import { ToolbarItemLocation } from 'devextreme/common';
import { NestedOptionHost } from 'devextreme-angular/core';
import { CollectionNestedOption } from 'devextreme-angular/core';
import { DxiDiagramItemComponent } from './item-dxi';
import * as i0 from "@angular/core";
export declare class DxiDiagramCommandComponent extends CollectionNestedOption {
    get icon(): string;
    set icon(value: string);
    get items(): Array<Command | CustomCommand>;
    set items(value: Array<Command | CustomCommand>);
    get location(): ToolbarItemLocation;
    set location(value: ToolbarItemLocation);
    get name(): Command | string;
    set name(value: Command | string);
    get text(): string;
    set text(value: string);
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiDiagramItemComponent>;
    set itemsChildren(value: QueryList<DxiDiagramItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiDiagramCommandComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiDiagramCommandComponent, "dxi-diagram-command", never, { "icon": { "alias": "icon"; "required": false; }; "items": { "alias": "items"; "required": false; }; "location": { "alias": "location"; "required": false; }; "name": { "alias": "name"; "required": false; }; "text": { "alias": "text"; "required": false; }; }, {}, ["itemsChildren"], never, false, never>;
}
export declare class DxiDiagramCommandModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiDiagramCommandModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxiDiagramCommandModule, [typeof DxiDiagramCommandComponent], never, [typeof DxiDiagramCommandComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxiDiagramCommandModule>;
}
