/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { ShapeCategory, ToolboxDisplayMode, ShapeType } from 'devextreme/ui/diagram';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDiagramContextToolboxComponent extends NestedOption implements OnDestroy, OnInit {
    get category(): ShapeCategory | string;
    set category(value: ShapeCategory | string);
    get displayMode(): ToolboxDisplayMode;
    set displayMode(value: ToolboxDisplayMode);
    get enabled(): boolean;
    set enabled(value: boolean);
    get shapeIconsPerRow(): number;
    set shapeIconsPerRow(value: number);
    get shapes(): Array<ShapeType>;
    set shapes(value: Array<ShapeType>);
    get width(): number;
    set width(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDiagramContextToolboxComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDiagramContextToolboxComponent, "dxo-diagram-context-toolbox", never, { "category": { "alias": "category"; "required": false; }; "displayMode": { "alias": "displayMode"; "required": false; }; "enabled": { "alias": "enabled"; "required": false; }; "shapeIconsPerRow": { "alias": "shapeIconsPerRow"; "required": false; }; "shapes": { "alias": "shapes"; "required": false; }; "width": { "alias": "width"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDiagramContextToolboxModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDiagramContextToolboxModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDiagramContextToolboxModule, [typeof DxoDiagramContextToolboxComponent], never, [typeof DxoDiagramContextToolboxComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDiagramContextToolboxModule>;
}
