/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { QueryList } from '@angular/core';
import { Command, CustomCommand, ShapeCategory, ToolboxDisplayMode, ShapeType } from 'devextreme/ui/diagram';
import { NestedOptionHost } from 'devextreme-angular/core';
import { CollectionNestedOption } from 'devextreme-angular/core';
import { DxiDiagramCommandComponent } from './command-dxi';
import * as i0 from "@angular/core";
export declare class DxiDiagramGroupComponent extends CollectionNestedOption {
    get commands(): Array<Command | CustomCommand>;
    set commands(value: Array<Command | CustomCommand>);
    get title(): string;
    set title(value: string);
    get category(): ShapeCategory | string;
    set category(value: ShapeCategory | string);
    get displayMode(): ToolboxDisplayMode;
    set displayMode(value: ToolboxDisplayMode);
    get expanded(): boolean;
    set expanded(value: boolean);
    get shapes(): Array<ShapeType>;
    set shapes(value: Array<ShapeType>);
    protected get _optionPath(): string;
    get commandsChildren(): QueryList<DxiDiagramCommandComponent>;
    set commandsChildren(value: QueryList<DxiDiagramCommandComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiDiagramGroupComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiDiagramGroupComponent, "dxi-diagram-group", never, { "commands": { "alias": "commands"; "required": false; }; "title": { "alias": "title"; "required": false; }; "category": { "alias": "category"; "required": false; }; "displayMode": { "alias": "displayMode"; "required": false; }; "expanded": { "alias": "expanded"; "required": false; }; "shapes": { "alias": "shapes"; "required": false; }; }, {}, ["commandsChildren"], never, false, never>;
}
export declare class DxiDiagramGroupModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiDiagramGroupModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxiDiagramGroupModule, [typeof DxiDiagramGroupComponent], never, [typeof DxiDiagramGroupComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxiDiagramGroupModule>;
}
