/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import DataSource from 'devextreme/data/data_source';
import { DataLayoutType } from 'devextreme/ui/diagram';
import { Orientation } from 'devextreme/common';
import { DataSourceOptions } from 'devextreme/data/data_source';
import { Store } from 'devextreme/data/store';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDiagramNodesComponent extends NestedOption implements OnDestroy, OnInit {
    get autoLayout(): DataLayoutType | {
        orientation?: Orientation;
        type?: DataLayoutType;
    };
    set autoLayout(value: DataLayoutType | {
        orientation?: Orientation;
        type?: DataLayoutType;
    });
    get autoSizeEnabled(): boolean;
    set autoSizeEnabled(value: boolean);
    get containerChildrenExpr(): ((data: any, value: any) => any) | string | undefined;
    set containerChildrenExpr(value: ((data: any, value: any) => any) | string | undefined);
    get containerKeyExpr(): ((data: any, value: any) => any) | string;
    set containerKeyExpr(value: ((data: any, value: any) => any) | string);
    get customDataExpr(): ((data: any, value: any) => any) | string | undefined;
    set customDataExpr(value: ((data: any, value: any) => any) | string | undefined);
    get dataSource(): Array<any> | DataSource | DataSourceOptions | null | Store | string;
    set dataSource(value: Array<any> | DataSource | DataSourceOptions | null | Store | string);
    get heightExpr(): ((data: any, value: any) => any) | string | undefined;
    set heightExpr(value: ((data: any, value: any) => any) | string | undefined);
    get imageUrlExpr(): ((data: any, value: any) => any) | string | undefined;
    set imageUrlExpr(value: ((data: any, value: any) => any) | string | undefined);
    get itemsExpr(): ((data: any, value: any) => any) | string | undefined;
    set itemsExpr(value: ((data: any, value: any) => any) | string | undefined);
    get keyExpr(): ((data: any, value: any) => any) | string;
    set keyExpr(value: ((data: any, value: any) => any) | string);
    get leftExpr(): ((data: any, value: any) => any) | string | undefined;
    set leftExpr(value: ((data: any, value: any) => any) | string | undefined);
    get lockedExpr(): ((data: any, value: any) => any) | string | undefined;
    set lockedExpr(value: ((data: any, value: any) => any) | string | undefined);
    get parentKeyExpr(): ((data: any, value: any) => any) | string | undefined;
    set parentKeyExpr(value: ((data: any, value: any) => any) | string | undefined);
    get styleExpr(): ((data: any, value: any) => any) | string | undefined;
    set styleExpr(value: ((data: any, value: any) => any) | string | undefined);
    get textExpr(): ((data: any, value: any) => any) | string;
    set textExpr(value: ((data: any, value: any) => any) | string);
    get textStyleExpr(): ((data: any, value: any) => any) | string | undefined;
    set textStyleExpr(value: ((data: any, value: any) => any) | string | undefined);
    get topExpr(): ((data: any, value: any) => any) | string | undefined;
    set topExpr(value: ((data: any, value: any) => any) | string | undefined);
    get typeExpr(): ((data: any, value: any) => any) | string;
    set typeExpr(value: ((data: any, value: any) => any) | string);
    get widthExpr(): ((data: any, value: any) => any) | string | undefined;
    set widthExpr(value: ((data: any, value: any) => any) | string | undefined);
    get zIndexExpr(): ((data: any, value: any) => any) | string | undefined;
    set zIndexExpr(value: ((data: any, value: any) => any) | string | undefined);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDiagramNodesComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDiagramNodesComponent, "dxo-diagram-nodes", never, { "autoLayout": { "alias": "autoLayout"; "required": false; }; "autoSizeEnabled": { "alias": "autoSizeEnabled"; "required": false; }; "containerChildrenExpr": { "alias": "containerChildrenExpr"; "required": false; }; "containerKeyExpr": { "alias": "containerKeyExpr"; "required": false; }; "customDataExpr": { "alias": "customDataExpr"; "required": false; }; "dataSource": { "alias": "dataSource"; "required": false; }; "heightExpr": { "alias": "heightExpr"; "required": false; }; "imageUrlExpr": { "alias": "imageUrlExpr"; "required": false; }; "itemsExpr": { "alias": "itemsExpr"; "required": false; }; "keyExpr": { "alias": "keyExpr"; "required": false; }; "leftExpr": { "alias": "leftExpr"; "required": false; }; "lockedExpr": { "alias": "lockedExpr"; "required": false; }; "parentKeyExpr": { "alias": "parentKeyExpr"; "required": false; }; "styleExpr": { "alias": "styleExpr"; "required": false; }; "textExpr": { "alias": "textExpr"; "required": false; }; "textStyleExpr": { "alias": "textStyleExpr"; "required": false; }; "topExpr": { "alias": "topExpr"; "required": false; }; "typeExpr": { "alias": "typeExpr"; "required": false; }; "widthExpr": { "alias": "widthExpr"; "required": false; }; "zIndexExpr": { "alias": "zIndexExpr"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDiagramNodesModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDiagramNodesModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDiagramNodesModule, [typeof DxoDiagramNodesComponent], never, [typeof DxoDiagramNodesComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDiagramNodesModule>;
}
