/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { Command, CustomCommand, PanelVisibility } from 'devextreme/ui/diagram';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiDiagramTabComponent } from './tab-dxi';
import * as i0 from "@angular/core";
export declare class DxoDiagramPropertiesPanelComponent extends NestedOption implements OnDestroy, OnInit {
    get tabs(): {
        commands?: Array<Command | CustomCommand>;
        groups?: {
            commands?: Array<Command | CustomCommand>;
            title?: string;
        }[];
        title?: string;
    }[];
    set tabs(value: {
        commands?: Array<Command | CustomCommand>;
        groups?: {
            commands?: Array<Command | CustomCommand>;
            title?: string;
        }[];
        title?: string;
    }[]);
    get visibility(): PanelVisibility;
    set visibility(value: PanelVisibility);
    protected get _optionPath(): string;
    get tabsChildren(): QueryList<DxiDiagramTabComponent>;
    set tabsChildren(value: QueryList<DxiDiagramTabComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDiagramPropertiesPanelComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDiagramPropertiesPanelComponent, "dxo-diagram-properties-panel", never, { "tabs": { "alias": "tabs"; "required": false; }; "visibility": { "alias": "visibility"; "required": false; }; }, {}, ["tabsChildren"], never, false, never>;
}
export declare class DxoDiagramPropertiesPanelModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDiagramPropertiesPanelModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDiagramPropertiesPanelModule, [typeof DxoDiagramPropertiesPanelComponent], never, [typeof DxoDiagramPropertiesPanelComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDiagramPropertiesPanelModule>;
}
