/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { QueryList } from '@angular/core';
import { Command, CustomCommand } from 'devextreme/ui/diagram';
import { NestedOptionHost } from 'devextreme-angular/core';
import { CollectionNestedOption } from 'devextreme-angular/core';
import { DxiDiagramCommandComponent } from './command-dxi';
import { DxiDiagramGroupComponent } from './group-dxi';
import { DxiDiagramTabGroupComponent } from './tab-group-dxi';
import * as i0 from "@angular/core";
export declare class DxiDiagramTabComponent extends CollectionNestedOption {
    get commands(): Array<Command | CustomCommand>;
    set commands(value: Array<Command | CustomCommand>);
    get groups(): {
        commands?: Array<Command | CustomCommand>;
        title?: string;
    }[];
    set groups(value: {
        commands?: Array<Command | CustomCommand>;
        title?: string;
    }[]);
    get title(): string;
    set title(value: string);
    protected get _optionPath(): string;
    get commandsChildren(): QueryList<DxiDiagramCommandComponent>;
    set commandsChildren(value: QueryList<DxiDiagramCommandComponent>);
    get groupsChildren(): QueryList<DxiDiagramGroupComponent>;
    set groupsChildren(value: QueryList<DxiDiagramGroupComponent>);
    get tabGroupsChildren(): QueryList<DxiDiagramTabGroupComponent>;
    set tabGroupsChildren(value: QueryList<DxiDiagramTabGroupComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiDiagramTabComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiDiagramTabComponent, "dxi-diagram-tab", never, { "commands": { "alias": "commands"; "required": false; }; "groups": { "alias": "groups"; "required": false; }; "title": { "alias": "title"; "required": false; }; }, {}, ["commandsChildren", "groupsChildren", "tabGroupsChildren"], never, false, never>;
}
export declare class DxiDiagramTabModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiDiagramTabModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxiDiagramTabModule, [typeof DxiDiagramTabComponent], never, [typeof DxiDiagramTabComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxiDiagramTabModule>;
}
