/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { QueryList } from '@angular/core';
import { dxFileManagerContextMenuItem, FileManagerPredefinedContextMenuItem } from 'devextreme/ui/file_manager';
import { NestedOptionHost } from 'devextreme-angular/core';
import { CollectionNestedOption } from 'devextreme-angular/core';
import { DxiFileManagerItemComponent } from './item-dxi';
import * as i0 from "@angular/core";
export declare class DxiFileManagerContextMenuItemComponent extends CollectionNestedOption {
    get beginGroup(): boolean;
    set beginGroup(value: boolean);
    get closeMenuOnClick(): boolean;
    set closeMenuOnClick(value: boolean);
    get disabled(): boolean;
    set disabled(value: boolean);
    get icon(): string;
    set icon(value: string);
    get items(): Array<dxFileManagerContextMenuItem>;
    set items(value: Array<dxFileManagerContextMenuItem>);
    get name(): FileManagerPredefinedContextMenuItem | string;
    set name(value: FileManagerPredefinedContextMenuItem | string);
    get selectable(): boolean;
    set selectable(value: boolean);
    get selected(): boolean;
    set selected(value: boolean);
    get text(): string;
    set text(value: string);
    get visible(): boolean | undefined;
    set visible(value: boolean | undefined);
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiFileManagerItemComponent>;
    set itemsChildren(value: QueryList<DxiFileManagerItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiFileManagerContextMenuItemComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiFileManagerContextMenuItemComponent, "dxi-file-manager-context-menu-item", never, { "beginGroup": { "alias": "beginGroup"; "required": false; }; "closeMenuOnClick": { "alias": "closeMenuOnClick"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "icon": { "alias": "icon"; "required": false; }; "items": { "alias": "items"; "required": false; }; "name": { "alias": "name"; "required": false; }; "selectable": { "alias": "selectable"; "required": false; }; "selected": { "alias": "selected"; "required": false; }; "text": { "alias": "text"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; }, {}, ["itemsChildren"], never, false, never>;
}
export declare class DxiFileManagerContextMenuItemModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiFileManagerContextMenuItemModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxiFileManagerContextMenuItemModule, [typeof DxiFileManagerContextMenuItemComponent], never, [typeof DxiFileManagerContextMenuItemComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxiFileManagerContextMenuItemModule>;
}
