/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { dxFileManagerContextMenuItem, FileManagerPredefinedContextMenuItem } from 'devextreme/ui/file_manager';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiFileManagerContextMenuItemComponent } from './context-menu-item-dxi';
import { DxiFileManagerItemComponent } from './item-dxi';
import * as i0 from "@angular/core";
export declare class DxoFileManagerContextMenuComponent extends NestedOption implements OnDestroy, OnInit {
    get items(): Array<dxFileManagerContextMenuItem | FileManagerPredefinedContextMenuItem>;
    set items(value: Array<dxFileManagerContextMenuItem | FileManagerPredefinedContextMenuItem>);
    protected get _optionPath(): string;
    get contextMenuItemsChildren(): QueryList<DxiFileManagerContextMenuItemComponent>;
    set contextMenuItemsChildren(value: QueryList<DxiFileManagerContextMenuItemComponent>);
    get itemsChildren(): QueryList<DxiFileManagerItemComponent>;
    set itemsChildren(value: QueryList<DxiFileManagerItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFileManagerContextMenuComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoFileManagerContextMenuComponent, "dxo-file-manager-context-menu", never, { "items": { "alias": "items"; "required": false; }; }, {}, ["contextMenuItemsChildren", "itemsChildren"], never, false, never>;
}
export declare class DxoFileManagerContextMenuModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFileManagerContextMenuModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoFileManagerContextMenuModule, [typeof DxoFileManagerContextMenuComponent], never, [typeof DxoFileManagerContextMenuComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoFileManagerContextMenuModule>;
}
