/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { dxFileManagerToolbarItem, FileManagerPredefinedToolbarItem } from 'devextreme/ui/file_manager';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiFileManagerFileSelectionItemComponent } from './file-selection-item-dxi';
import { DxiFileManagerItemComponent } from './item-dxi';
import { DxiFileManagerToolbarItemComponent } from './toolbar-item-dxi';
import * as i0 from "@angular/core";
export declare class DxoFileManagerToolbarComponent extends NestedOption implements OnDestroy, OnInit {
    get fileSelectionItems(): Array<dxFileManagerToolbarItem | FileManagerPredefinedToolbarItem>;
    set fileSelectionItems(value: Array<dxFileManagerToolbarItem | FileManagerPredefinedToolbarItem>);
    get items(): Array<dxFileManagerToolbarItem | FileManagerPredefinedToolbarItem>;
    set items(value: Array<dxFileManagerToolbarItem | FileManagerPredefinedToolbarItem>);
    protected get _optionPath(): string;
    get fileSelectionItemsChildren(): QueryList<DxiFileManagerFileSelectionItemComponent>;
    set fileSelectionItemsChildren(value: QueryList<DxiFileManagerFileSelectionItemComponent>);
    get itemsChildren(): QueryList<DxiFileManagerItemComponent>;
    set itemsChildren(value: QueryList<DxiFileManagerItemComponent>);
    get toolbarItemsChildren(): QueryList<DxiFileManagerToolbarItemComponent>;
    set toolbarItemsChildren(value: QueryList<DxiFileManagerToolbarItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFileManagerToolbarComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoFileManagerToolbarComponent, "dxo-file-manager-toolbar", never, { "fileSelectionItems": { "alias": "fileSelectionItems"; "required": false; }; "items": { "alias": "items"; "required": false; }; }, {}, ["fileSelectionItemsChildren", "itemsChildren", "toolbarItemsChildren"], never, false, never>;
}
export declare class DxoFileManagerToolbarModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFileManagerToolbarModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoFileManagerToolbarModule, [typeof DxoFileManagerToolbarComponent], never, [typeof DxoFileManagerToolbarComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoFileManagerToolbarModule>;
}
