/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { ElementRef, Renderer2, AfterViewInit, QueryList } from '@angular/core';
import * as CommonTypes from 'devextreme/common';
import { FormItemComponent, FormItemType, LabelLocation } from 'devextreme/ui/form';
import { HorizontalAlignment } from 'devextreme/common';
import { NestedOptionHost, DxTemplateDirective, IDxTemplateHost, DxTemplateHost } from 'devextreme-angular/core';
import { CollectionNestedOption } from 'devextreme-angular/core';
import { DxiFormAsyncRuleComponent } from './async-rule-dxi';
import { DxiFormCompareRuleComponent } from './compare-rule-dxi';
import { DxiFormCustomRuleComponent } from './custom-rule-dxi';
import { DxiFormEmailRuleComponent } from './email-rule-dxi';
import { DxiFormNumericRuleComponent } from './numeric-rule-dxi';
import { DxiFormPatternRuleComponent } from './pattern-rule-dxi';
import { DxiFormRangeRuleComponent } from './range-rule-dxi';
import { DxiFormRequiredRuleComponent } from './required-rule-dxi';
import { DxiFormStringLengthRuleComponent } from './string-length-rule-dxi';
import { DxiFormValidationRuleComponent } from './validation-rule-dxi';
import * as i0 from "@angular/core";
export declare class DxiFormSimpleItemComponent extends CollectionNestedOption implements AfterViewInit, IDxTemplateHost {
    private renderer;
    private document;
    private element;
    get colSpan(): number | undefined;
    set colSpan(value: number | undefined);
    get cssClass(): string | undefined;
    set cssClass(value: string | undefined);
    get dataField(): string | undefined;
    set dataField(value: string | undefined);
    get editorOptions(): any | undefined;
    set editorOptions(value: any | undefined);
    get editorType(): FormItemComponent;
    set editorType(value: FormItemComponent);
    get helpText(): string | undefined;
    set helpText(value: string | undefined);
    get isRequired(): boolean | undefined;
    set isRequired(value: boolean | undefined);
    get itemType(): FormItemType;
    set itemType(value: FormItemType);
    get label(): {
        alignment?: HorizontalAlignment;
        location?: LabelLocation;
        showColon?: boolean;
        template?: any;
        text?: string | undefined;
        visible?: boolean;
    };
    set label(value: {
        alignment?: HorizontalAlignment;
        location?: LabelLocation;
        showColon?: boolean;
        template?: any;
        text?: string | undefined;
        visible?: boolean;
    });
    get name(): string | undefined;
    set name(value: string | undefined);
    get template(): any;
    set template(value: any);
    get validationRules(): Array<CommonTypes.ValidationRule>;
    set validationRules(value: Array<CommonTypes.ValidationRule>);
    get visible(): boolean;
    set visible(value: boolean);
    get visibleIndex(): number | undefined;
    set visibleIndex(value: number | undefined);
    protected get _optionPath(): string;
    get asyncRulesChildren(): QueryList<DxiFormAsyncRuleComponent>;
    set asyncRulesChildren(value: QueryList<DxiFormAsyncRuleComponent>);
    get compareRulesChildren(): QueryList<DxiFormCompareRuleComponent>;
    set compareRulesChildren(value: QueryList<DxiFormCompareRuleComponent>);
    get customRulesChildren(): QueryList<DxiFormCustomRuleComponent>;
    set customRulesChildren(value: QueryList<DxiFormCustomRuleComponent>);
    get emailRulesChildren(): QueryList<DxiFormEmailRuleComponent>;
    set emailRulesChildren(value: QueryList<DxiFormEmailRuleComponent>);
    get numericRulesChildren(): QueryList<DxiFormNumericRuleComponent>;
    set numericRulesChildren(value: QueryList<DxiFormNumericRuleComponent>);
    get patternRulesChildren(): QueryList<DxiFormPatternRuleComponent>;
    set patternRulesChildren(value: QueryList<DxiFormPatternRuleComponent>);
    get rangeRulesChildren(): QueryList<DxiFormRangeRuleComponent>;
    set rangeRulesChildren(value: QueryList<DxiFormRangeRuleComponent>);
    get requiredRulesChildren(): QueryList<DxiFormRequiredRuleComponent>;
    set requiredRulesChildren(value: QueryList<DxiFormRequiredRuleComponent>);
    get stringLengthRulesChildren(): QueryList<DxiFormStringLengthRuleComponent>;
    set stringLengthRulesChildren(value: QueryList<DxiFormStringLengthRuleComponent>);
    get validationRulesChildren(): QueryList<DxiFormValidationRuleComponent>;
    set validationRulesChildren(value: QueryList<DxiFormValidationRuleComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost, renderer: Renderer2, document: any, templateHost: DxTemplateHost, element: ElementRef);
    setTemplate(template: DxTemplateDirective): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiFormSimpleItemComponent, [{ host: true; skipSelf: true; }, { host: true; }, null, null, { host: true; }, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiFormSimpleItemComponent, "dxi-form-simple-item", never, { "colSpan": { "alias": "colSpan"; "required": false; }; "cssClass": { "alias": "cssClass"; "required": false; }; "dataField": { "alias": "dataField"; "required": false; }; "editorOptions": { "alias": "editorOptions"; "required": false; }; "editorType": { "alias": "editorType"; "required": false; }; "helpText": { "alias": "helpText"; "required": false; }; "isRequired": { "alias": "isRequired"; "required": false; }; "itemType": { "alias": "itemType"; "required": false; }; "label": { "alias": "label"; "required": false; }; "name": { "alias": "name"; "required": false; }; "template": { "alias": "template"; "required": false; }; "validationRules": { "alias": "validationRules"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; "visibleIndex": { "alias": "visibleIndex"; "required": false; }; }, {}, ["asyncRulesChildren", "compareRulesChildren", "customRulesChildren", "emailRulesChildren", "numericRulesChildren", "patternRulesChildren", "rangeRulesChildren", "requiredRulesChildren", "stringLengthRulesChildren", "validationRulesChildren"], ["*"], false, never>;
}
export declare class DxiFormSimpleItemModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiFormSimpleItemModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxiFormSimpleItemModule, [typeof DxiFormSimpleItemComponent], never, [typeof DxiFormSimpleItemComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxiFormSimpleItemModule>;
}
