/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { DashStyle, Font, LabelPosition, TextOverflow, WordWrap } from 'devextreme/common/charts';
import { dxFunnelItem } from 'devextreme/viz/funnel';
import { Format } from 'devextreme/common/core/localization';
import { HorizontalEdge } from 'devextreme/common';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoFunnelLabelComponent extends NestedOption implements OnDestroy, OnInit {
    get backgroundColor(): string;
    set backgroundColor(value: string);
    get border(): {
        color?: string;
        dashStyle?: DashStyle;
        visible?: boolean;
        width?: number;
    };
    set border(value: {
        color?: string;
        dashStyle?: DashStyle;
        visible?: boolean;
        width?: number;
    });
    get connector(): {
        color?: string | undefined;
        opacity?: number;
        visible?: boolean;
        width?: number;
    };
    set connector(value: {
        color?: string | undefined;
        opacity?: number;
        visible?: boolean;
        width?: number;
    });
    get customizeText(): ((itemInfo: {
        item: dxFunnelItem;
        percent: number;
        percentText: string;
        value: number;
        valueText: string;
    }) => string);
    set customizeText(value: ((itemInfo: {
        item: dxFunnelItem;
        percent: number;
        percentText: string;
        value: number;
        valueText: string;
    }) => string));
    get font(): Font;
    set font(value: Font);
    get format(): Format | undefined;
    set format(value: Format | undefined);
    get horizontalAlignment(): HorizontalEdge;
    set horizontalAlignment(value: HorizontalEdge);
    get horizontalOffset(): number;
    set horizontalOffset(value: number);
    get position(): LabelPosition;
    set position(value: LabelPosition);
    get showForZeroValues(): boolean;
    set showForZeroValues(value: boolean);
    get textOverflow(): TextOverflow;
    set textOverflow(value: TextOverflow);
    get visible(): boolean;
    set visible(value: boolean);
    get wordWrap(): WordWrap;
    set wordWrap(value: WordWrap);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFunnelLabelComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoFunnelLabelComponent, "dxo-funnel-label", never, { "backgroundColor": { "alias": "backgroundColor"; "required": false; }; "border": { "alias": "border"; "required": false; }; "connector": { "alias": "connector"; "required": false; }; "customizeText": { "alias": "customizeText"; "required": false; }; "font": { "alias": "font"; "required": false; }; "format": { "alias": "format"; "required": false; }; "horizontalAlignment": { "alias": "horizontalAlignment"; "required": false; }; "horizontalOffset": { "alias": "horizontalOffset"; "required": false; }; "position": { "alias": "position"; "required": false; }; "showForZeroValues": { "alias": "showForZeroValues"; "required": false; }; "textOverflow": { "alias": "textOverflow"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; "wordWrap": { "alias": "wordWrap"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoFunnelLabelModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFunnelLabelModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoFunnelLabelModule, [typeof DxoFunnelLabelComponent], never, [typeof DxoFunnelLabelComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoFunnelLabelModule>;
}
