/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { dxGanttContextMenuItem, GanttPredefinedContextMenuItem } from 'devextreme/ui/gantt';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiGanttContextMenuItemComponent } from './context-menu-item-dxi';
import { DxiGanttItemComponent } from './item-dxi';
import * as i0 from "@angular/core";
export declare class DxoGanttContextMenuComponent extends NestedOption implements OnDestroy, OnInit {
    get enabled(): boolean;
    set enabled(value: boolean);
    get items(): Array<dxGanttContextMenuItem | GanttPredefinedContextMenuItem>;
    set items(value: Array<dxGanttContextMenuItem | GanttPredefinedContextMenuItem>);
    protected get _optionPath(): string;
    get contextMenuItemsChildren(): QueryList<DxiGanttContextMenuItemComponent>;
    set contextMenuItemsChildren(value: QueryList<DxiGanttContextMenuItemComponent>);
    get itemsChildren(): QueryList<DxiGanttItemComponent>;
    set itemsChildren(value: QueryList<DxiGanttItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoGanttContextMenuComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoGanttContextMenuComponent, "dxo-gantt-context-menu", never, { "enabled": { "alias": "enabled"; "required": false; }; "items": { "alias": "items"; "required": false; }; }, {}, ["contextMenuItemsChildren", "itemsChildren"], never, false, never>;
}
export declare class DxoGanttContextMenuModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoGanttContextMenuModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoGanttContextMenuModule, [typeof DxoGanttContextMenuComponent], never, [typeof DxoGanttContextMenuComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoGanttContextMenuModule>;
}
