/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { dxGanttToolbarItem, GanttPredefinedToolbarItem } from 'devextreme/ui/gantt';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiGanttItemComponent } from './item-dxi';
import { DxiGanttToolbarItemComponent } from './toolbar-item-dxi';
import * as i0 from "@angular/core";
export declare class DxoGanttToolbarComponent extends NestedOption implements OnDestroy, OnInit {
    get items(): Array<dxGanttToolbarItem | GanttPredefinedToolbarItem>;
    set items(value: Array<dxGanttToolbarItem | GanttPredefinedToolbarItem>);
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiGanttItemComponent>;
    set itemsChildren(value: QueryList<DxiGanttItemComponent>);
    get toolbarItemsChildren(): QueryList<DxiGanttToolbarItemComponent>;
    set toolbarItemsChildren(value: QueryList<DxiGanttToolbarItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoGanttToolbarComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoGanttToolbarComponent, "dxo-gantt-toolbar", never, { "items": { "alias": "items"; "required": false; }; }, {}, ["itemsChildren", "toolbarItemsChildren"], never, false, never>;
}
export declare class DxoGanttToolbarModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoGanttToolbarModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoGanttToolbarModule, [typeof DxoGanttToolbarComponent], never, [typeof DxoGanttToolbarComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoGanttToolbarModule>;
}
