/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { dxFileUploaderOptions } from 'devextreme/ui/file_uploader';
import { HtmlEditorImageUploadMode, dxHtmlEditorImageUploadTabItem, HtmlEditorImageUploadTab } from 'devextreme/ui/html_editor';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiHtmlEditorTabComponent } from './tab-dxi';
import * as i0 from "@angular/core";
export declare class DxoHtmlEditorImageUploadComponent extends NestedOption implements OnDestroy, OnInit {
    get fileUploaderOptions(): dxFileUploaderOptions;
    set fileUploaderOptions(value: dxFileUploaderOptions);
    get fileUploadMode(): HtmlEditorImageUploadMode;
    set fileUploadMode(value: HtmlEditorImageUploadMode);
    get tabs(): Array<dxHtmlEditorImageUploadTabItem | HtmlEditorImageUploadTab>;
    set tabs(value: Array<dxHtmlEditorImageUploadTabItem | HtmlEditorImageUploadTab>);
    get uploadDirectory(): string | undefined;
    set uploadDirectory(value: string | undefined);
    get uploadUrl(): string | undefined;
    set uploadUrl(value: string | undefined);
    protected get _optionPath(): string;
    get tabsChildren(): QueryList<DxiHtmlEditorTabComponent>;
    set tabsChildren(value: QueryList<DxiHtmlEditorTabComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoHtmlEditorImageUploadComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoHtmlEditorImageUploadComponent, "dxo-html-editor-image-upload", never, { "fileUploaderOptions": { "alias": "fileUploaderOptions"; "required": false; }; "fileUploadMode": { "alias": "fileUploadMode"; "required": false; }; "tabs": { "alias": "tabs"; "required": false; }; "uploadDirectory": { "alias": "uploadDirectory"; "required": false; }; "uploadUrl": { "alias": "uploadUrl"; "required": false; }; }, {}, ["tabsChildren"], never, false, never>;
}
export declare class DxoHtmlEditorImageUploadModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoHtmlEditorImageUploadModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoHtmlEditorImageUploadModule, [typeof DxoHtmlEditorImageUploadComponent], never, [typeof DxoHtmlEditorImageUploadComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoHtmlEditorImageUploadModule>;
}
