/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { dxHtmlEditorTableContextMenuItem, HtmlEditorPredefinedContextMenuItem } from 'devextreme/ui/html_editor';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiHtmlEditorItemComponent } from './item-dxi';
import { DxiHtmlEditorTableContextMenuItemComponent } from './table-context-menu-item-dxi';
import * as i0 from "@angular/core";
export declare class DxoHtmlEditorTableContextMenuComponent extends NestedOption implements OnDestroy, OnInit {
    get enabled(): boolean;
    set enabled(value: boolean);
    get items(): Array<dxHtmlEditorTableContextMenuItem | HtmlEditorPredefinedContextMenuItem>;
    set items(value: Array<dxHtmlEditorTableContextMenuItem | HtmlEditorPredefinedContextMenuItem>);
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiHtmlEditorItemComponent>;
    set itemsChildren(value: QueryList<DxiHtmlEditorItemComponent>);
    get tableContextMenuItemsChildren(): QueryList<DxiHtmlEditorTableContextMenuItemComponent>;
    set tableContextMenuItemsChildren(value: QueryList<DxiHtmlEditorTableContextMenuItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoHtmlEditorTableContextMenuComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoHtmlEditorTableContextMenuComponent, "dxo-html-editor-table-context-menu", never, { "enabled": { "alias": "enabled"; "required": false; }; "items": { "alias": "items"; "required": false; }; }, {}, ["itemsChildren", "tableContextMenuItemsChildren"], never, false, never>;
}
export declare class DxoHtmlEditorTableContextMenuModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoHtmlEditorTableContextMenuModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoHtmlEditorTableContextMenuModule, [typeof DxoHtmlEditorTableContextMenuComponent], never, [typeof DxoHtmlEditorTableContextMenuComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoHtmlEditorTableContextMenuModule>;
}
