/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { dxHtmlEditorToolbarItem, HtmlEditorPredefinedToolbarItem } from 'devextreme/ui/html_editor';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiHtmlEditorItemComponent } from './item-dxi';
import { DxiHtmlEditorToolbarItemComponent } from './toolbar-item-dxi';
import * as i0 from "@angular/core";
export declare class DxoHtmlEditorToolbarComponent extends NestedOption implements OnDestroy, OnInit {
    get container(): any | string;
    set container(value: any | string);
    get items(): Array<dxHtmlEditorToolbarItem | HtmlEditorPredefinedToolbarItem>;
    set items(value: Array<dxHtmlEditorToolbarItem | HtmlEditorPredefinedToolbarItem>);
    get multiline(): boolean;
    set multiline(value: boolean);
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiHtmlEditorItemComponent>;
    set itemsChildren(value: QueryList<DxiHtmlEditorItemComponent>);
    get toolbarItemsChildren(): QueryList<DxiHtmlEditorToolbarItemComponent>;
    set toolbarItemsChildren(value: QueryList<DxiHtmlEditorToolbarItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoHtmlEditorToolbarComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoHtmlEditorToolbarComponent, "dxo-html-editor-toolbar", never, { "container": { "alias": "container"; "required": false; }; "items": { "alias": "items"; "required": false; }; "multiline": { "alias": "multiline"; "required": false; }; }, {}, ["itemsChildren", "toolbarItemsChildren"], never, false, never>;
}
export declare class DxoHtmlEditorToolbarModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoHtmlEditorToolbarModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoHtmlEditorToolbarModule, [typeof DxoHtmlEditorToolbarComponent], never, [typeof DxoHtmlEditorToolbarComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoHtmlEditorToolbarModule>;
}
