/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { NestedOption } from 'devextreme-angular/core';
import { dxContextMenuItem } from 'devextreme/ui/context_menu';
import { Command, CustomCommand } from 'devextreme/ui/diagram';
import { dxFileManagerContextMenuItem, FileManagerPredefinedContextMenuItem } from 'devextreme/ui/file_manager';
import { GanttPredefinedContextMenuItem } from 'devextreme/ui/gantt';
import * as i0 from "@angular/core";
export declare abstract class DxoFileManagerContextMenu extends NestedOption {
    get commands(): Array<CustomCommand | Command>;
    set commands(value: Array<CustomCommand | Command>);
    get enabled(): boolean;
    set enabled(value: boolean);
    get items(): Array<dxFileManagerContextMenuItem | FileManagerPredefinedContextMenuItem | GanttPredefinedContextMenuItem | any | {
        beginGroup?: boolean;
        closeMenuOnClick?: boolean;
        disabled?: boolean;
        icon?: string;
        items?: Array<dxContextMenuItem>;
        name?: GanttPredefinedContextMenuItem | string;
        selectable?: boolean;
        selected?: boolean;
        template?: any;
        text?: string;
        visible?: boolean;
    }>;
    set items(value: Array<dxFileManagerContextMenuItem | FileManagerPredefinedContextMenuItem | GanttPredefinedContextMenuItem | any | {
        beginGroup?: boolean;
        closeMenuOnClick?: boolean;
        disabled?: boolean;
        icon?: string;
        items?: Array<dxContextMenuItem>;
        name?: GanttPredefinedContextMenuItem | string;
        selectable?: boolean;
        selected?: boolean;
        template?: any;
        text?: string;
        visible?: boolean;
    }>);
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoFileManagerContextMenu, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoFileManagerContextMenu, "ng-component", never, {}, {}, never, never, false, never>;
}
