/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { CollectionNestedOption } from 'devextreme-angular/core';
import { DataType } from 'devextreme/common';
import { Format } from 'devextreme/common/core/localization';
import { Store } from 'devextreme/data';
import { Options as DataSourceOptions } from 'devextreme/data/data_source';
import { FilterBuilderOperation } from 'devextreme/ui/filter_builder';
import * as i0 from "@angular/core";
export declare abstract class DxiFilterBuilderField extends CollectionNestedOption {
    get calculateFilterExpression(): Function;
    set calculateFilterExpression(value: Function);
    get caption(): string | undefined;
    set caption(value: string | undefined);
    get customizeText(): Function;
    set customizeText(value: Function);
    get dataField(): string | undefined;
    set dataField(value: string | undefined);
    get dataType(): DataType;
    set dataType(value: DataType);
    get editorOptions(): any;
    set editorOptions(value: any);
    get editorTemplate(): any;
    set editorTemplate(value: any);
    get falseText(): string;
    set falseText(value: string);
    get filterOperations(): Array<FilterBuilderOperation | string>;
    set filterOperations(value: Array<FilterBuilderOperation | string>);
    get format(): Format | string;
    set format(value: Format | string);
    get lookup(): {
        allowClearing?: boolean;
        dataSource?: Store | DataSourceOptions | undefined | Array<any>;
        displayExpr?: Function | string | undefined;
        valueExpr?: Function | string | undefined;
    };
    set lookup(value: {
        allowClearing?: boolean;
        dataSource?: Store | DataSourceOptions | undefined | Array<any>;
        displayExpr?: Function | string | undefined;
        valueExpr?: Function | string | undefined;
    });
    get name(): string | undefined;
    set name(value: string | undefined);
    get trueText(): string;
    set trueText(value: string);
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiFilterBuilderField, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiFilterBuilderField, "ng-component", never, {}, {}, never, never, false, never>;
}
