/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { NestedOption } from 'devextreme-angular/core';
import { HorizontalEdge, VerticalEdge } from 'devextreme/common';
import { ChartsColor, Font, Palette } from 'devextreme/common/charts';
import { Format } from 'devextreme/common/core/localization';
import * as i0 from "@angular/core";
export declare abstract class DxoGaugeIndicator extends NestedOption {
    get arrowLength(): number;
    set arrowLength(value: number);
    get backgroundColor(): string;
    set backgroundColor(value: string);
    get baseValue(): number | undefined;
    set baseValue(value: number | undefined);
    get beginAdaptingAtRadius(): number;
    set beginAdaptingAtRadius(value: number);
    get color(): ChartsColor | string;
    set color(value: ChartsColor | string);
    get horizontalOrientation(): HorizontalEdge;
    set horizontalOrientation(value: HorizontalEdge);
    get indentFromCenter(): number;
    set indentFromCenter(value: number);
    get length(): number;
    set length(value: number);
    get offset(): number;
    set offset(value: number);
    get palette(): Palette | string | Array<string>;
    set palette(value: Palette | string | Array<string>);
    get secondColor(): string;
    set secondColor(value: string);
    get secondFraction(): number;
    set secondFraction(value: number);
    get size(): number;
    set size(value: number);
    get spindleGapSize(): number;
    set spindleGapSize(value: number);
    get spindleSize(): number;
    set spindleSize(value: number);
    get text(): {
        customizeText?: Function | undefined;
        font?: Font;
        format?: Format | string | undefined;
        indent?: number;
    };
    set text(value: {
        customizeText?: Function | undefined;
        font?: Font;
        format?: Format | string | undefined;
        indent?: number;
    });
    get type(): string;
    set type(value: string);
    get verticalOrientation(): VerticalEdge;
    set verticalOrientation(value: VerticalEdge);
    get width(): number;
    set width(value: number);
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoGaugeIndicator, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoGaugeIndicator, "ng-component", never, {}, {}, never, never, false, never>;
}
