/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { CollectionNestedOption } from 'devextreme-angular/core';
import { Command, CustomCommand } from 'devextreme/ui/diagram';
import { ButtonItem, EmptyItem, GroupItem, SimpleItem, TabbedItem } from 'devextreme/ui/form';
import { HtmlEditorImageUploadTab } from 'devextreme/ui/html_editor';
import * as i0 from "@angular/core";
export declare abstract class DxiHtmlEditorImageUploadTabItem extends CollectionNestedOption {
    get alignItemLabels(): boolean;
    set alignItemLabels(value: boolean);
    get badge(): string | undefined;
    set badge(value: string | undefined);
    get colCount(): number;
    set colCount(value: number);
    get colCountByScreen(): {
        lg?: number | undefined;
        md?: number | undefined;
        sm?: number | undefined;
        xs?: number | undefined;
    };
    set colCountByScreen(value: {
        lg?: number | undefined;
        md?: number | undefined;
        sm?: number | undefined;
        xs?: number | undefined;
    });
    get disabled(): boolean;
    set disabled(value: boolean);
    get icon(): string | undefined;
    set icon(value: string | undefined);
    get items(): Array<SimpleItem | GroupItem | TabbedItem | EmptyItem | ButtonItem>;
    set items(value: Array<SimpleItem | GroupItem | TabbedItem | EmptyItem | ButtonItem>);
    get tabTemplate(): any | undefined;
    set tabTemplate(value: any | undefined);
    get template(): any | undefined;
    set template(value: any | undefined);
    get title(): string | undefined;
    set title(value: string | undefined);
    get commands(): Array<CustomCommand | Command>;
    set commands(value: Array<CustomCommand | Command>);
    get groups(): Array<any | {
        commands?: Array<CustomCommand | Command>;
        title?: string;
    }>;
    set groups(value: Array<any | {
        commands?: Array<CustomCommand | Command>;
        title?: string;
    }>);
    get name(): HtmlEditorImageUploadTab | undefined;
    set name(value: HtmlEditorImageUploadTab | undefined);
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiHtmlEditorImageUploadTabItem, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiHtmlEditorImageUploadTabItem, "ng-component", never, {}, {}, never, never, false, never>;
}
