/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { ChartsDataType, Palette, PaletteExtensionMode } from 'devextreme/common/charts';
import { ChartSeries } from 'devextreme/viz/common';
import { ChartAxisScale } from 'devextreme/viz/range_selector';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiSeriesComponent } from './series-dxi';
import * as i0 from "@angular/core";
export declare class DxoChartComponent extends NestedOption implements OnDestroy, OnInit {
    get barGroupPadding(): number;
    set barGroupPadding(value: number);
    get barGroupWidth(): number | undefined;
    set barGroupWidth(value: number | undefined);
    get bottomIndent(): number;
    set bottomIndent(value: number);
    get commonSeriesSettings(): any;
    set commonSeriesSettings(value: any);
    get dataPrepareSettings(): {
        checkTypeForAllData?: boolean;
        convertToAxisDataType?: boolean;
        sortingMethod?: boolean | Function;
    };
    set dataPrepareSettings(value: {
        checkTypeForAllData?: boolean;
        convertToAxisDataType?: boolean;
        sortingMethod?: boolean | Function;
    });
    get maxBubbleSize(): number;
    set maxBubbleSize(value: number);
    get minBubbleSize(): number;
    set minBubbleSize(value: number);
    get negativesAsZeroes(): boolean;
    set negativesAsZeroes(value: boolean);
    get palette(): Palette | string | Array<string>;
    set palette(value: Palette | string | Array<string>);
    get paletteExtensionMode(): PaletteExtensionMode;
    set paletteExtensionMode(value: PaletteExtensionMode);
    get series(): ChartSeries | any | undefined | Array<ChartSeries | any>;
    set series(value: ChartSeries | any | undefined | Array<ChartSeries | any>);
    get seriesTemplate(): {
        customizeSeries?: Function;
        nameField?: string;
    };
    set seriesTemplate(value: {
        customizeSeries?: Function;
        nameField?: string;
    });
    get topIndent(): number;
    set topIndent(value: number);
    get valueAxis(): {
        inverted?: boolean;
        logarithmBase?: number;
        max?: number | undefined;
        min?: number | undefined;
        type?: ChartAxisScale | undefined;
        valueType?: ChartsDataType | undefined;
    };
    set valueAxis(value: {
        inverted?: boolean;
        logarithmBase?: number;
        max?: number | undefined;
        min?: number | undefined;
        type?: ChartAxisScale | undefined;
        valueType?: ChartsDataType | undefined;
    });
    protected get _optionPath(): string;
    get seriesChildren(): QueryList<DxiSeriesComponent>;
    set seriesChildren(value: QueryList<DxiSeriesComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoChartComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoChartComponent, "dxo-chart", never, { "barGroupPadding": { "alias": "barGroupPadding"; "required": false; }; "barGroupWidth": { "alias": "barGroupWidth"; "required": false; }; "bottomIndent": { "alias": "bottomIndent"; "required": false; }; "commonSeriesSettings": { "alias": "commonSeriesSettings"; "required": false; }; "dataPrepareSettings": { "alias": "dataPrepareSettings"; "required": false; }; "maxBubbleSize": { "alias": "maxBubbleSize"; "required": false; }; "minBubbleSize": { "alias": "minBubbleSize"; "required": false; }; "negativesAsZeroes": { "alias": "negativesAsZeroes"; "required": false; }; "palette": { "alias": "palette"; "required": false; }; "paletteExtensionMode": { "alias": "paletteExtensionMode"; "required": false; }; "series": { "alias": "series"; "required": false; }; "seriesTemplate": { "alias": "seriesTemplate"; "required": false; }; "topIndent": { "alias": "topIndent"; "required": false; }; "valueAxis": { "alias": "valueAxis"; "required": false; }; }, {}, ["seriesChildren"], never, false, never>;
}
export declare class DxoChartModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoChartModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoChartModule, [typeof DxoChartComponent], never, [typeof DxoChartComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoChartModule>;
}
