/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { ElementRef, Renderer2, AfterViewInit, QueryList } from '@angular/core';
import { ShapeType } from 'devextreme/ui/diagram';
import { NestedOptionHost, DxTemplateDirective, IDxTemplateHost, DxTemplateHost } from 'devextreme-angular/core';
import { CollectionNestedOption } from 'devextreme-angular/core';
import { DxiConnectionPointComponent } from './connection-point-dxi';
import * as i0 from "@angular/core";
export declare class DxiCustomShapeComponent extends CollectionNestedOption implements AfterViewInit, IDxTemplateHost {
    private renderer;
    private document;
    private element;
    get allowEditImage(): boolean;
    set allowEditImage(value: boolean);
    get allowEditText(): boolean;
    set allowEditText(value: boolean);
    get allowResize(): boolean;
    set allowResize(value: boolean);
    get backgroundImageHeight(): number;
    set backgroundImageHeight(value: number);
    get backgroundImageLeft(): number;
    set backgroundImageLeft(value: number);
    get backgroundImageToolboxUrl(): string;
    set backgroundImageToolboxUrl(value: string);
    get backgroundImageTop(): number;
    set backgroundImageTop(value: number);
    get backgroundImageUrl(): string;
    set backgroundImageUrl(value: string);
    get backgroundImageWidth(): number;
    set backgroundImageWidth(value: number);
    get baseType(): ShapeType | string;
    set baseType(value: ShapeType | string);
    get category(): string;
    set category(value: string);
    get connectionPoints(): Array<any | {
        x?: number;
        y?: number;
    }>;
    set connectionPoints(value: Array<any | {
        x?: number;
        y?: number;
    }>);
    get defaultHeight(): number;
    set defaultHeight(value: number);
    get defaultImageUrl(): string;
    set defaultImageUrl(value: string);
    get defaultText(): string;
    set defaultText(value: string);
    get defaultWidth(): number;
    set defaultWidth(value: number);
    get imageHeight(): number;
    set imageHeight(value: number);
    get imageLeft(): number;
    set imageLeft(value: number);
    get imageTop(): number;
    set imageTop(value: number);
    get imageWidth(): number;
    set imageWidth(value: number);
    get keepRatioOnAutoSize(): boolean;
    set keepRatioOnAutoSize(value: boolean);
    get maxHeight(): number;
    set maxHeight(value: number);
    get maxWidth(): number;
    set maxWidth(value: number);
    get minHeight(): number;
    set minHeight(value: number);
    get minWidth(): number;
    set minWidth(value: number);
    get template(): any;
    set template(value: any);
    get templateHeight(): number;
    set templateHeight(value: number);
    get templateLeft(): number;
    set templateLeft(value: number);
    get templateTop(): number;
    set templateTop(value: number);
    get templateWidth(): number;
    set templateWidth(value: number);
    get textHeight(): number;
    set textHeight(value: number);
    get textLeft(): number;
    set textLeft(value: number);
    get textTop(): number;
    set textTop(value: number);
    get textWidth(): number;
    set textWidth(value: number);
    get title(): string;
    set title(value: string);
    get toolboxTemplate(): any;
    set toolboxTemplate(value: any);
    get toolboxWidthToHeightRatio(): number;
    set toolboxWidthToHeightRatio(value: number);
    get type(): string;
    set type(value: string);
    protected get _optionPath(): string;
    get connectionPointsChildren(): QueryList<DxiConnectionPointComponent>;
    set connectionPointsChildren(value: QueryList<DxiConnectionPointComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost, renderer: Renderer2, document: any, templateHost: DxTemplateHost, element: ElementRef);
    setTemplate(template: DxTemplateDirective): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiCustomShapeComponent, [{ host: true; skipSelf: true; }, { host: true; }, null, null, { host: true; }, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiCustomShapeComponent, "dxi-custom-shape", never, { "allowEditImage": { "alias": "allowEditImage"; "required": false; }; "allowEditText": { "alias": "allowEditText"; "required": false; }; "allowResize": { "alias": "allowResize"; "required": false; }; "backgroundImageHeight": { "alias": "backgroundImageHeight"; "required": false; }; "backgroundImageLeft": { "alias": "backgroundImageLeft"; "required": false; }; "backgroundImageToolboxUrl": { "alias": "backgroundImageToolboxUrl"; "required": false; }; "backgroundImageTop": { "alias": "backgroundImageTop"; "required": false; }; "backgroundImageUrl": { "alias": "backgroundImageUrl"; "required": false; }; "backgroundImageWidth": { "alias": "backgroundImageWidth"; "required": false; }; "baseType": { "alias": "baseType"; "required": false; }; "category": { "alias": "category"; "required": false; }; "connectionPoints": { "alias": "connectionPoints"; "required": false; }; "defaultHeight": { "alias": "defaultHeight"; "required": false; }; "defaultImageUrl": { "alias": "defaultImageUrl"; "required": false; }; "defaultText": { "alias": "defaultText"; "required": false; }; "defaultWidth": { "alias": "defaultWidth"; "required": false; }; "imageHeight": { "alias": "imageHeight"; "required": false; }; "imageLeft": { "alias": "imageLeft"; "required": false; }; "imageTop": { "alias": "imageTop"; "required": false; }; "imageWidth": { "alias": "imageWidth"; "required": false; }; "keepRatioOnAutoSize": { "alias": "keepRatioOnAutoSize"; "required": false; }; "maxHeight": { "alias": "maxHeight"; "required": false; }; "maxWidth": { "alias": "maxWidth"; "required": false; }; "minHeight": { "alias": "minHeight"; "required": false; }; "minWidth": { "alias": "minWidth"; "required": false; }; "template": { "alias": "template"; "required": false; }; "templateHeight": { "alias": "templateHeight"; "required": false; }; "templateLeft": { "alias": "templateLeft"; "required": false; }; "templateTop": { "alias": "templateTop"; "required": false; }; "templateWidth": { "alias": "templateWidth"; "required": false; }; "textHeight": { "alias": "textHeight"; "required": false; }; "textLeft": { "alias": "textLeft"; "required": false; }; "textTop": { "alias": "textTop"; "required": false; }; "textWidth": { "alias": "textWidth"; "required": false; }; "title": { "alias": "title"; "required": false; }; "toolboxTemplate": { "alias": "toolboxTemplate"; "required": false; }; "toolboxWidthToHeightRatio": { "alias": "toolboxWidthToHeightRatio"; "required": false; }; "type": { "alias": "type"; "required": false; }; }, {}, ["connectionPointsChildren"], ["*"], false, never>;
}
export declare class DxiCustomShapeModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiCustomShapeModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxiCustomShapeModule, [typeof DxiCustomShapeComponent], never, [typeof DxiCustomShapeComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxiCustomShapeModule>;
}
