/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Store } from 'devextreme/data';
import DataSource, { Options as DataSourceOptions } from 'devextreme/data/data_source';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoDependenciesComponent extends NestedOption implements OnDestroy, OnInit {
    get dataSource(): Store | DataSource | DataSourceOptions | null | string | Array<any>;
    set dataSource(value: Store | DataSource | DataSourceOptions | null | string | Array<any>);
    get keyExpr(): Function | string;
    set keyExpr(value: Function | string);
    get predecessorIdExpr(): Function | string;
    set predecessorIdExpr(value: Function | string);
    get successorIdExpr(): Function | string;
    set successorIdExpr(value: Function | string);
    get typeExpr(): Function | string;
    set typeExpr(value: Function | string);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDependenciesComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoDependenciesComponent, "dxo-dependencies", never, { "dataSource": { "alias": "dataSource"; "required": false; }; "keyExpr": { "alias": "keyExpr"; "required": false; }; "predecessorIdExpr": { "alias": "predecessorIdExpr"; "required": false; }; "successorIdExpr": { "alias": "successorIdExpr"; "required": false; }; "typeExpr": { "alias": "typeExpr"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoDependenciesModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoDependenciesModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoDependenciesModule, [typeof DxoDependenciesComponent], never, [typeof DxoDependenciesComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoDependenciesModule>;
}
