/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Store } from 'devextreme/data';
import DataSource, { Options as DataSourceOptions } from 'devextreme/data/data_source';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoEdgesComponent extends NestedOption implements OnDestroy, OnInit {
    get customDataExpr(): Function | string | undefined;
    set customDataExpr(value: Function | string | undefined);
    get dataSource(): Store | DataSource | DataSourceOptions | null | string | Array<any>;
    set dataSource(value: Store | DataSource | DataSourceOptions | null | string | Array<any>);
    get fromExpr(): Function | string;
    set fromExpr(value: Function | string);
    get fromLineEndExpr(): Function | string | undefined;
    set fromLineEndExpr(value: Function | string | undefined);
    get fromPointIndexExpr(): Function | string | undefined;
    set fromPointIndexExpr(value: Function | string | undefined);
    get keyExpr(): Function | string;
    set keyExpr(value: Function | string);
    get lineTypeExpr(): Function | string | undefined;
    set lineTypeExpr(value: Function | string | undefined);
    get lockedExpr(): Function | string | undefined;
    set lockedExpr(value: Function | string | undefined);
    get pointsExpr(): Function | string | undefined;
    set pointsExpr(value: Function | string | undefined);
    get styleExpr(): Function | string | undefined;
    set styleExpr(value: Function | string | undefined);
    get textExpr(): Function | string | undefined;
    set textExpr(value: Function | string | undefined);
    get textStyleExpr(): Function | string | undefined;
    set textStyleExpr(value: Function | string | undefined);
    get toExpr(): Function | string;
    set toExpr(value: Function | string);
    get toLineEndExpr(): Function | string | undefined;
    set toLineEndExpr(value: Function | string | undefined);
    get toPointIndexExpr(): Function | string | undefined;
    set toPointIndexExpr(value: Function | string | undefined);
    get zIndexExpr(): Function | string | undefined;
    set zIndexExpr(value: Function | string | undefined);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoEdgesComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoEdgesComponent, "dxo-edges", never, { "customDataExpr": { "alias": "customDataExpr"; "required": false; }; "dataSource": { "alias": "dataSource"; "required": false; }; "fromExpr": { "alias": "fromExpr"; "required": false; }; "fromLineEndExpr": { "alias": "fromLineEndExpr"; "required": false; }; "fromPointIndexExpr": { "alias": "fromPointIndexExpr"; "required": false; }; "keyExpr": { "alias": "keyExpr"; "required": false; }; "lineTypeExpr": { "alias": "lineTypeExpr"; "required": false; }; "lockedExpr": { "alias": "lockedExpr"; "required": false; }; "pointsExpr": { "alias": "pointsExpr"; "required": false; }; "styleExpr": { "alias": "styleExpr"; "required": false; }; "textExpr": { "alias": "textExpr"; "required": false; }; "textStyleExpr": { "alias": "textStyleExpr"; "required": false; }; "toExpr": { "alias": "toExpr"; "required": false; }; "toLineEndExpr": { "alias": "toLineEndExpr"; "required": false; }; "toPointIndexExpr": { "alias": "toPointIndexExpr"; "required": false; }; "zIndexExpr": { "alias": "zIndexExpr"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoEdgesModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoEdgesModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoEdgesModule, [typeof DxoEdgesComponent], never, [typeof DxoEdgesComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoEdgesModule>;
}
