/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, EventEmitter, QueryList } from '@angular/core';
import { DataChange, GridsEditMode, GridsEditRefreshMode, NewRowPosition, StartEditAction } from 'devextreme/common/grids';
import { Properties as dxFormOptions } from 'devextreme/ui/form';
import { Properties as dxPopupOptions } from 'devextreme/ui/popup';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiChangeComponent } from './change-dxi';
import * as i0 from "@angular/core";
export declare class DxoEditingComponent extends NestedOption implements OnDestroy, OnInit {
    get allowAdding(): boolean | Function;
    set allowAdding(value: boolean | Function);
    get allowDeleting(): boolean | Function;
    set allowDeleting(value: boolean | Function);
    get allowUpdating(): boolean | Function;
    set allowUpdating(value: boolean | Function);
    get changes(): Array<DataChange>;
    set changes(value: Array<DataChange>);
    get confirmDelete(): boolean;
    set confirmDelete(value: boolean);
    get editColumnName(): string;
    set editColumnName(value: string);
    get editRowKey(): any;
    set editRowKey(value: any);
    get form(): dxFormOptions;
    set form(value: dxFormOptions);
    get mode(): GridsEditMode;
    set mode(value: GridsEditMode);
    get newRowPosition(): NewRowPosition;
    set newRowPosition(value: NewRowPosition);
    get popup(): dxPopupOptions;
    set popup(value: dxPopupOptions);
    get refreshMode(): GridsEditRefreshMode;
    set refreshMode(value: GridsEditRefreshMode);
    get selectTextOnEditStart(): boolean;
    set selectTextOnEditStart(value: boolean);
    get startEditAction(): StartEditAction;
    set startEditAction(value: StartEditAction);
    get texts(): {
        addRow?: string;
        cancelAllChanges?: string;
        cancelRowChanges?: string;
        confirmDeleteMessage?: string;
        confirmDeleteTitle?: string;
        deleteRow?: string;
        editRow?: string;
        saveAllChanges?: string;
        saveRowChanges?: string;
        undeleteRow?: string;
        validationCancelChanges?: string;
    } | {
        addRow?: string;
        addRowToNode?: string;
        cancelAllChanges?: string;
        cancelRowChanges?: string;
        confirmDeleteMessage?: string;
        confirmDeleteTitle?: string;
        deleteRow?: string;
        editRow?: string;
        saveAllChanges?: string;
        saveRowChanges?: string;
        undeleteRow?: string;
        validationCancelChanges?: string;
    };
    set texts(value: {
        addRow?: string;
        cancelAllChanges?: string;
        cancelRowChanges?: string;
        confirmDeleteMessage?: string;
        confirmDeleteTitle?: string;
        deleteRow?: string;
        editRow?: string;
        saveAllChanges?: string;
        saveRowChanges?: string;
        undeleteRow?: string;
        validationCancelChanges?: string;
    } | {
        addRow?: string;
        addRowToNode?: string;
        cancelAllChanges?: string;
        cancelRowChanges?: string;
        confirmDeleteMessage?: string;
        confirmDeleteTitle?: string;
        deleteRow?: string;
        editRow?: string;
        saveAllChanges?: string;
        saveRowChanges?: string;
        undeleteRow?: string;
        validationCancelChanges?: string;
    });
    get useIcons(): boolean;
    set useIcons(value: boolean);
    get allowAddShape(): boolean;
    set allowAddShape(value: boolean);
    get allowChangeConnection(): boolean;
    set allowChangeConnection(value: boolean);
    get allowChangeConnectorPoints(): boolean;
    set allowChangeConnectorPoints(value: boolean);
    get allowChangeConnectorText(): boolean;
    set allowChangeConnectorText(value: boolean);
    get allowChangeShapeText(): boolean;
    set allowChangeShapeText(value: boolean);
    get allowDeleteConnector(): boolean;
    set allowDeleteConnector(value: boolean);
    get allowDeleteShape(): boolean;
    set allowDeleteShape(value: boolean);
    get allowMoveShape(): boolean;
    set allowMoveShape(value: boolean);
    get allowResizeShape(): boolean;
    set allowResizeShape(value: boolean);
    get allowDependencyAdding(): boolean;
    set allowDependencyAdding(value: boolean);
    get allowDependencyDeleting(): boolean;
    set allowDependencyDeleting(value: boolean);
    get allowResourceAdding(): boolean;
    set allowResourceAdding(value: boolean);
    get allowResourceDeleting(): boolean;
    set allowResourceDeleting(value: boolean);
    get allowResourceUpdating(): boolean;
    set allowResourceUpdating(value: boolean);
    get allowTaskAdding(): boolean;
    set allowTaskAdding(value: boolean);
    get allowTaskDeleting(): boolean;
    set allowTaskDeleting(value: boolean);
    get allowTaskResourceUpdating(): boolean;
    set allowTaskResourceUpdating(value: boolean);
    get allowTaskUpdating(): boolean;
    set allowTaskUpdating(value: boolean);
    get enabled(): boolean;
    set enabled(value: boolean);
    get allowDragging(): boolean;
    set allowDragging(value: boolean);
    get allowResizing(): boolean;
    set allowResizing(value: boolean);
    get allowTimeZoneEditing(): boolean;
    set allowTimeZoneEditing(value: boolean);
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    changesChange: EventEmitter<Array<DataChange>>;
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    editColumnNameChange: EventEmitter<string>;
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    editRowKeyChange: EventEmitter<any>;
    protected get _optionPath(): string;
    get changesChildren(): QueryList<DxiChangeComponent>;
    set changesChildren(value: QueryList<DxiChangeComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoEditingComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoEditingComponent, "dxo-editing", never, { "allowAdding": { "alias": "allowAdding"; "required": false; }; "allowDeleting": { "alias": "allowDeleting"; "required": false; }; "allowUpdating": { "alias": "allowUpdating"; "required": false; }; "changes": { "alias": "changes"; "required": false; }; "confirmDelete": { "alias": "confirmDelete"; "required": false; }; "editColumnName": { "alias": "editColumnName"; "required": false; }; "editRowKey": { "alias": "editRowKey"; "required": false; }; "form": { "alias": "form"; "required": false; }; "mode": { "alias": "mode"; "required": false; }; "newRowPosition": { "alias": "newRowPosition"; "required": false; }; "popup": { "alias": "popup"; "required": false; }; "refreshMode": { "alias": "refreshMode"; "required": false; }; "selectTextOnEditStart": { "alias": "selectTextOnEditStart"; "required": false; }; "startEditAction": { "alias": "startEditAction"; "required": false; }; "texts": { "alias": "texts"; "required": false; }; "useIcons": { "alias": "useIcons"; "required": false; }; "allowAddShape": { "alias": "allowAddShape"; "required": false; }; "allowChangeConnection": { "alias": "allowChangeConnection"; "required": false; }; "allowChangeConnectorPoints": { "alias": "allowChangeConnectorPoints"; "required": false; }; "allowChangeConnectorText": { "alias": "allowChangeConnectorText"; "required": false; }; "allowChangeShapeText": { "alias": "allowChangeShapeText"; "required": false; }; "allowDeleteConnector": { "alias": "allowDeleteConnector"; "required": false; }; "allowDeleteShape": { "alias": "allowDeleteShape"; "required": false; }; "allowMoveShape": { "alias": "allowMoveShape"; "required": false; }; "allowResizeShape": { "alias": "allowResizeShape"; "required": false; }; "allowDependencyAdding": { "alias": "allowDependencyAdding"; "required": false; }; "allowDependencyDeleting": { "alias": "allowDependencyDeleting"; "required": false; }; "allowResourceAdding": { "alias": "allowResourceAdding"; "required": false; }; "allowResourceDeleting": { "alias": "allowResourceDeleting"; "required": false; }; "allowResourceUpdating": { "alias": "allowResourceUpdating"; "required": false; }; "allowTaskAdding": { "alias": "allowTaskAdding"; "required": false; }; "allowTaskDeleting": { "alias": "allowTaskDeleting"; "required": false; }; "allowTaskResourceUpdating": { "alias": "allowTaskResourceUpdating"; "required": false; }; "allowTaskUpdating": { "alias": "allowTaskUpdating"; "required": false; }; "enabled": { "alias": "enabled"; "required": false; }; "allowDragging": { "alias": "allowDragging"; "required": false; }; "allowResizing": { "alias": "allowResizing"; "required": false; }; "allowTimeZoneEditing": { "alias": "allowTimeZoneEditing"; "required": false; }; }, { "changesChange": "changesChange"; "editColumnNameChange": "editColumnNameChange"; "editRowKeyChange": "editRowKeyChange"; }, ["changesChildren"], never, false, never>;
}
export declare class DxoEditingModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoEditingModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoEditingModule, [typeof DxoEditingComponent], never, [typeof DxoEditingComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoEditingModule>;
}
