/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { ExportFormat } from 'devextreme/common';
import { DataGridExportFormat } from 'devextreme/ui/data_grid';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoExportComponent extends NestedOption implements OnDestroy, OnInit {
    get backgroundColor(): string;
    set backgroundColor(value: string);
    get enabled(): boolean;
    set enabled(value: boolean);
    get fileName(): string;
    set fileName(value: string);
    get formats(): any | Array<ExportFormat | DataGridExportFormat | string>;
    set formats(value: any | Array<ExportFormat | DataGridExportFormat | string>);
    get margin(): number;
    set margin(value: number);
    get printingEnabled(): boolean;
    set printingEnabled(value: boolean);
    get svgToCanvas(): Function | undefined;
    set svgToCanvas(value: Function | undefined);
    get allowExportSelectedData(): boolean;
    set allowExportSelectedData(value: boolean);
    get texts(): {
        exportAll?: string;
        exportSelectedRows?: string;
        exportTo?: string;
    };
    set texts(value: {
        exportAll?: string;
        exportSelectedRows?: string;
        exportTo?: string;
    });
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoExportComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoExportComponent, "dxo-export", never, { "backgroundColor": { "alias": "backgroundColor"; "required": false; }; "enabled": { "alias": "enabled"; "required": false; }; "fileName": { "alias": "fileName"; "required": false; }; "formats": { "alias": "formats"; "required": false; }; "margin": { "alias": "margin"; "required": false; }; "printingEnabled": { "alias": "printingEnabled"; "required": false; }; "svgToCanvas": { "alias": "svgToCanvas"; "required": false; }; "allowExportSelectedData": { "alias": "allowExportSelectedData"; "required": false; }; "texts": { "alias": "texts"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoExportModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoExportModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoExportModule, [typeof DxoExportComponent], never, [typeof DxoExportComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoExportModule>;
}
