/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { QueryList } from '@angular/core';
import { Command, CustomCommand, ShapeCategory, ShapeType, ToolboxDisplayMode } from 'devextreme/ui/diagram';
import { NestedOptionHost } from 'devextreme-angular/core';
import { CollectionNestedOption } from 'devextreme-angular/core';
import { DxiCommandComponent } from './command-dxi';
import * as i0 from "@angular/core";
export declare class DxiGroupComponent extends CollectionNestedOption {
    get commands(): Array<CustomCommand | Command>;
    set commands(value: Array<CustomCommand | Command>);
    get title(): string;
    set title(value: string);
    get category(): ShapeCategory | string;
    set category(value: ShapeCategory | string);
    get displayMode(): ToolboxDisplayMode;
    set displayMode(value: ToolboxDisplayMode);
    get expanded(): boolean;
    set expanded(value: boolean);
    get shapes(): Array<ShapeType | string>;
    set shapes(value: Array<ShapeType | string>);
    protected get _optionPath(): string;
    get commandsChildren(): QueryList<DxiCommandComponent>;
    set commandsChildren(value: QueryList<DxiCommandComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiGroupComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxiGroupComponent, "dxi-group", never, { "commands": { "alias": "commands"; "required": false; }; "title": { "alias": "title"; "required": false; }; "category": { "alias": "category"; "required": false; }; "displayMode": { "alias": "displayMode"; "required": false; }; "expanded": { "alias": "expanded"; "required": false; }; "shapes": { "alias": "shapes"; "required": false; }; }, {}, ["commandsChildren"], never, false, never>;
}
export declare class DxiGroupModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxiGroupModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxiGroupModule, [typeof DxiGroupComponent], never, [typeof DxiGroupComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxiGroupModule>;
}
