/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, ElementRef, Renderer2, AfterViewInit } from '@angular/core';
import { HorizontalAlignment, HorizontalEdge, Position, VerticalAlignment, VerticalEdge } from 'devextreme/common';
import { ChartsAxisLabelOverlap, DashStyle, Font, LabelOverlap, LabelPosition, RelativePosition, TextOverflow, WordWrap } from 'devextreme/common/charts';
import { Format } from 'devextreme/common/core/localization';
import { LabelLocation } from 'devextreme/ui/form';
import { ChartLabelDisplayMode } from 'devextreme/viz/chart';
import { CircularGaugeLabelOverlap } from 'devextreme/viz/circular_gauge';
import { NestedOptionHost, DxTemplateDirective, IDxTemplateHost, DxTemplateHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoLabelComponent extends NestedOption implements AfterViewInit, OnDestroy, OnInit, IDxTemplateHost {
    private renderer;
    private document;
    private element;
    get connectorColor(): string | undefined;
    set connectorColor(value: string | undefined);
    get connectorWidth(): number;
    set connectorWidth(value: number);
    get customizeText(): Function;
    set customizeText(value: Function);
    get font(): Font;
    set font(value: Font);
    get format(): Format | string | undefined;
    set format(value: Format | string | undefined);
    get indent(): number;
    set indent(value: number);
    get visible(): boolean;
    set visible(value: boolean);
    get horizontalAlignment(): HorizontalAlignment | HorizontalEdge;
    set horizontalAlignment(value: HorizontalAlignment | HorizontalEdge);
    get position(): RelativePosition | Position | LabelPosition | VerticalEdge;
    set position(value: RelativePosition | Position | LabelPosition | VerticalEdge);
    get text(): string | undefined;
    set text(value: string | undefined);
    get verticalAlignment(): VerticalAlignment;
    set verticalAlignment(value: VerticalAlignment);
    get alignment(): HorizontalAlignment | undefined;
    set alignment(value: HorizontalAlignment | undefined);
    get customizeHint(): Function;
    set customizeHint(value: Function);
    get displayMode(): ChartLabelDisplayMode;
    set displayMode(value: ChartLabelDisplayMode);
    get indentFromAxis(): number;
    set indentFromAxis(value: number);
    get overlappingBehavior(): ChartsAxisLabelOverlap | LabelOverlap | TextOverflow;
    set overlappingBehavior(value: ChartsAxisLabelOverlap | LabelOverlap | TextOverflow);
    get rotationAngle(): number;
    set rotationAngle(value: number);
    get staggeringSpacing(): number;
    set staggeringSpacing(value: number);
    get template(): any | undefined;
    set template(value: any | undefined);
    get textOverflow(): TextOverflow;
    set textOverflow(value: TextOverflow);
    get wordWrap(): WordWrap;
    set wordWrap(value: WordWrap);
    get argumentFormat(): Format | string | undefined;
    set argumentFormat(value: Format | string | undefined);
    get backgroundColor(): string | undefined;
    set backgroundColor(value: string | undefined);
    get border(): {
        color?: string | undefined;
        dashStyle?: DashStyle | undefined;
        visible?: boolean;
        width?: number;
    } | {
        color?: string;
        dashStyle?: DashStyle;
        visible?: boolean;
        width?: number;
    } | {
        color?: string | undefined;
        visible?: boolean | undefined;
        width?: number | undefined;
    };
    set border(value: {
        color?: string | undefined;
        dashStyle?: DashStyle | undefined;
        visible?: boolean;
        width?: number;
    } | {
        color?: string;
        dashStyle?: DashStyle;
        visible?: boolean;
        width?: number;
    } | {
        color?: string | undefined;
        visible?: boolean | undefined;
        width?: number | undefined;
    });
    get connector(): {
        color?: string | undefined;
        visible?: boolean;
        width?: number;
    } | {
        color?: string | undefined;
        opacity?: number;
        visible?: boolean;
        width?: number;
    };
    set connector(value: {
        color?: string | undefined;
        visible?: boolean;
        width?: number;
    } | {
        color?: string | undefined;
        opacity?: number;
        visible?: boolean;
        width?: number;
    });
    get displayFormat(): string | undefined;
    set displayFormat(value: string | undefined);
    get horizontalOffset(): number;
    set horizontalOffset(value: number);
    get showForZeroValues(): boolean;
    set showForZeroValues(value: boolean);
    get verticalOffset(): number;
    set verticalOffset(value: number);
    get hideFirstOrLast(): CircularGaugeLabelOverlap;
    set hideFirstOrLast(value: CircularGaugeLabelOverlap);
    get indentFromTick(): number;
    set indentFromTick(value: number);
    get useRangeColors(): boolean;
    set useRangeColors(value: boolean);
    get location(): LabelLocation;
    set location(value: LabelLocation);
    get showColon(): boolean;
    set showColon(value: boolean);
    get radialOffset(): number;
    set radialOffset(value: number);
    get topIndent(): number;
    set topIndent(value: number);
    get shadow(): {
        blur?: number;
        color?: string;
        offsetX?: number;
        offsetY?: number;
        opacity?: number;
    };
    set shadow(value: {
        blur?: number;
        color?: string;
        offsetX?: number;
        offsetY?: number;
        opacity?: number;
    });
    get useNodeColors(): boolean;
    set useNodeColors(value: boolean);
    get dataField(): string;
    set dataField(value: string);
    get enabled(): boolean;
    set enabled(value: boolean);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost, renderer: Renderer2, document: any, templateHost: DxTemplateHost, element: ElementRef);
    setTemplate(template: DxTemplateDirective): void;
    ngAfterViewInit(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoLabelComponent, [{ host: true; skipSelf: true; }, { host: true; }, null, null, { host: true; }, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoLabelComponent, "dxo-label", never, { "connectorColor": { "alias": "connectorColor"; "required": false; }; "connectorWidth": { "alias": "connectorWidth"; "required": false; }; "customizeText": { "alias": "customizeText"; "required": false; }; "font": { "alias": "font"; "required": false; }; "format": { "alias": "format"; "required": false; }; "indent": { "alias": "indent"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; "horizontalAlignment": { "alias": "horizontalAlignment"; "required": false; }; "position": { "alias": "position"; "required": false; }; "text": { "alias": "text"; "required": false; }; "verticalAlignment": { "alias": "verticalAlignment"; "required": false; }; "alignment": { "alias": "alignment"; "required": false; }; "customizeHint": { "alias": "customizeHint"; "required": false; }; "displayMode": { "alias": "displayMode"; "required": false; }; "indentFromAxis": { "alias": "indentFromAxis"; "required": false; }; "overlappingBehavior": { "alias": "overlappingBehavior"; "required": false; }; "rotationAngle": { "alias": "rotationAngle"; "required": false; }; "staggeringSpacing": { "alias": "staggeringSpacing"; "required": false; }; "template": { "alias": "template"; "required": false; }; "textOverflow": { "alias": "textOverflow"; "required": false; }; "wordWrap": { "alias": "wordWrap"; "required": false; }; "argumentFormat": { "alias": "argumentFormat"; "required": false; }; "backgroundColor": { "alias": "backgroundColor"; "required": false; }; "border": { "alias": "border"; "required": false; }; "connector": { "alias": "connector"; "required": false; }; "displayFormat": { "alias": "displayFormat"; "required": false; }; "horizontalOffset": { "alias": "horizontalOffset"; "required": false; }; "showForZeroValues": { "alias": "showForZeroValues"; "required": false; }; "verticalOffset": { "alias": "verticalOffset"; "required": false; }; "hideFirstOrLast": { "alias": "hideFirstOrLast"; "required": false; }; "indentFromTick": { "alias": "indentFromTick"; "required": false; }; "useRangeColors": { "alias": "useRangeColors"; "required": false; }; "location": { "alias": "location"; "required": false; }; "showColon": { "alias": "showColon"; "required": false; }; "radialOffset": { "alias": "radialOffset"; "required": false; }; "topIndent": { "alias": "topIndent"; "required": false; }; "shadow": { "alias": "shadow"; "required": false; }; "useNodeColors": { "alias": "useNodeColors"; "required": false; }; "dataField": { "alias": "dataField"; "required": false; }; "enabled": { "alias": "enabled"; "required": false; }; }, {}, never, ["*"], false, never>;
}
export declare class DxoLabelModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoLabelModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoLabelModule, [typeof DxoLabelComponent], never, [typeof DxoLabelComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoLabelModule>;
}
