/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Orientation } from 'devextreme/common';
import { Store } from 'devextreme/data';
import DataSource, { Options as DataSourceOptions } from 'devextreme/data/data_source';
import { DataLayoutType } from 'devextreme/ui/diagram';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoNodesComponent extends NestedOption implements OnDestroy, OnInit {
    get autoLayout(): DataLayoutType | {
        orientation?: Orientation;
        type?: DataLayoutType;
    };
    set autoLayout(value: DataLayoutType | {
        orientation?: Orientation;
        type?: DataLayoutType;
    });
    get autoSizeEnabled(): boolean;
    set autoSizeEnabled(value: boolean);
    get containerChildrenExpr(): Function | string | undefined;
    set containerChildrenExpr(value: Function | string | undefined);
    get containerKeyExpr(): Function | string;
    set containerKeyExpr(value: Function | string);
    get customDataExpr(): Function | string | undefined;
    set customDataExpr(value: Function | string | undefined);
    get dataSource(): Store | DataSource | DataSourceOptions | null | string | Array<any>;
    set dataSource(value: Store | DataSource | DataSourceOptions | null | string | Array<any>);
    get heightExpr(): Function | string | undefined;
    set heightExpr(value: Function | string | undefined);
    get imageUrlExpr(): Function | string | undefined;
    set imageUrlExpr(value: Function | string | undefined);
    get itemsExpr(): Function | string | undefined;
    set itemsExpr(value: Function | string | undefined);
    get keyExpr(): Function | string;
    set keyExpr(value: Function | string);
    get leftExpr(): Function | string | undefined;
    set leftExpr(value: Function | string | undefined);
    get lockedExpr(): Function | string | undefined;
    set lockedExpr(value: Function | string | undefined);
    get parentKeyExpr(): Function | string | undefined;
    set parentKeyExpr(value: Function | string | undefined);
    get styleExpr(): Function | string | undefined;
    set styleExpr(value: Function | string | undefined);
    get textExpr(): Function | string;
    set textExpr(value: Function | string);
    get textStyleExpr(): Function | string | undefined;
    set textStyleExpr(value: Function | string | undefined);
    get topExpr(): Function | string | undefined;
    set topExpr(value: Function | string | undefined);
    get typeExpr(): Function | string;
    set typeExpr(value: Function | string);
    get widthExpr(): Function | string | undefined;
    set widthExpr(value: Function | string | undefined);
    get zIndexExpr(): Function | string | undefined;
    set zIndexExpr(value: Function | string | undefined);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoNodesComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoNodesComponent, "dxo-nodes", never, { "autoLayout": { "alias": "autoLayout"; "required": false; }; "autoSizeEnabled": { "alias": "autoSizeEnabled"; "required": false; }; "containerChildrenExpr": { "alias": "containerChildrenExpr"; "required": false; }; "containerKeyExpr": { "alias": "containerKeyExpr"; "required": false; }; "customDataExpr": { "alias": "customDataExpr"; "required": false; }; "dataSource": { "alias": "dataSource"; "required": false; }; "heightExpr": { "alias": "heightExpr"; "required": false; }; "imageUrlExpr": { "alias": "imageUrlExpr"; "required": false; }; "itemsExpr": { "alias": "itemsExpr"; "required": false; }; "keyExpr": { "alias": "keyExpr"; "required": false; }; "leftExpr": { "alias": "leftExpr"; "required": false; }; "lockedExpr": { "alias": "lockedExpr"; "required": false; }; "parentKeyExpr": { "alias": "parentKeyExpr"; "required": false; }; "styleExpr": { "alias": "styleExpr"; "required": false; }; "textExpr": { "alias": "textExpr"; "required": false; }; "textStyleExpr": { "alias": "textStyleExpr"; "required": false; }; "topExpr": { "alias": "topExpr"; "required": false; }; "typeExpr": { "alias": "typeExpr"; "required": false; }; "widthExpr": { "alias": "widthExpr"; "required": false; }; "zIndexExpr": { "alias": "zIndexExpr"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoNodesModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoNodesModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoNodesModule, [typeof DxoNodesComponent], never, [typeof DxoNodesComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoNodesModule>;
}
