/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, EventEmitter, QueryList } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiItemComponent } from './item-dxi';
import * as i0 from "@angular/core";
export declare class DxoPageSizeComponent extends NestedOption implements OnDestroy, OnInit {
    get height(): number;
    set height(value: number);
    get items(): Array<any | {
        height?: number;
        text?: string;
        width?: number;
    }>;
    set items(value: Array<any | {
        height?: number;
        text?: string;
        width?: number;
    }>);
    get width(): number;
    set width(value: number);
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    heightChange: EventEmitter<number>;
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    widthChange: EventEmitter<number>;
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiItemComponent>;
    set itemsChildren(value: QueryList<DxiItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPageSizeComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoPageSizeComponent, "dxo-page-size", never, { "height": { "alias": "height"; "required": false; }; "items": { "alias": "items"; "required": false; }; "width": { "alias": "width"; "required": false; }; }, { "heightChange": "heightChange"; "widthChange": "widthChange"; }, ["itemsChildren"], never, false, never>;
}
export declare class DxoPageSizeModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPageSizeModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoPageSizeModule, [typeof DxoPageSizeComponent], never, [typeof DxoPageSizeComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoPageSizeModule>;
}
