/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { Command, CustomCommand, PanelVisibility } from 'devextreme/ui/diagram';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiTabComponent } from './tab-dxi';
import * as i0 from "@angular/core";
export declare class DxoPropertiesPanelComponent extends NestedOption implements OnDestroy, OnInit {
    get tabs(): Array<any | {
        commands?: Array<CustomCommand | Command>;
        groups?: Array<any | {
            commands?: Array<CustomCommand | Command>;
            title?: string;
        }>;
        title?: string;
    }>;
    set tabs(value: Array<any | {
        commands?: Array<CustomCommand | Command>;
        groups?: Array<any | {
            commands?: Array<CustomCommand | Command>;
            title?: string;
        }>;
        title?: string;
    }>);
    get visibility(): PanelVisibility;
    set visibility(value: PanelVisibility);
    protected get _optionPath(): string;
    get tabsChildren(): QueryList<DxiTabComponent>;
    set tabsChildren(value: QueryList<DxiTabComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPropertiesPanelComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoPropertiesPanelComponent, "dxo-properties-panel", never, { "tabs": { "alias": "tabs"; "required": false; }; "visibility": { "alias": "visibility"; "required": false; }; }, {}, ["tabsChildren"], never, false, never>;
}
export declare class DxoPropertiesPanelModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPropertiesPanelModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoPropertiesPanelModule, [typeof DxoPropertiesPanelComponent], never, [typeof DxoPropertiesPanelComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoPropertiesPanelModule>;
}
