/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Store } from 'devextreme/data';
import DataSource, { Options as DataSourceOptions } from 'devextreme/data/data_source';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoResourcesComponent extends NestedOption implements OnDestroy, OnInit {
    get colorExpr(): Function | string;
    set colorExpr(value: Function | string);
    get dataSource(): Store | DataSource | DataSourceOptions | null | string | Array<any>;
    set dataSource(value: Store | DataSource | DataSourceOptions | null | string | Array<any>);
    get keyExpr(): Function | string;
    set keyExpr(value: Function | string);
    get textExpr(): Function | string;
    set textExpr(value: Function | string);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoResourcesComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoResourcesComponent, "dxo-resources", never, { "colorExpr": { "alias": "colorExpr"; "required": false; }; "dataSource": { "alias": "dataSource"; "required": false; }; "keyExpr": { "alias": "keyExpr"; "required": false; }; "textExpr": { "alias": "textExpr"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoResourcesModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoResourcesModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoResourcesModule, [typeof DxoResourcesComponent], never, [typeof DxoResourcesComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoResourcesModule>;
}
