/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, EventEmitter, QueryList } from '@angular/core';
import { Properties as dxSplitterOptions } from 'devextreme/ui/splitter';
import { NestedOptionHost } from 'devextreme-angular/core';
import { DxoSplitterOptions } from './base/splitter-options';
import { DxiItemComponent } from './item-dxi';
import * as i0 from "@angular/core";
export declare class DxoSplitterComponent extends DxoSplitterOptions implements OnDestroy, OnInit {
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    itemsChange: EventEmitter<Array<any | {
        collapsed?: boolean;
        collapsedSize?: number | string | undefined;
        collapsible?: boolean;
        maxSize?: number | string | undefined;
        minSize?: number | string | undefined;
        resizable?: boolean;
        size?: number | string | undefined;
        splitter?: dxSplitterOptions | undefined;
        template?: any;
        text?: string;
        visible?: boolean;
    }>>;
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiItemComponent>;
    set itemsChildren(value: QueryList<DxiItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoSplitterComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoSplitterComponent, "dxo-splitter", never, { "allowKeyboardNavigation": { "alias": "allowKeyboardNavigation"; "required": false; }; "dataSource": { "alias": "dataSource"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "elementAttr": { "alias": "elementAttr"; "required": false; }; "height": { "alias": "height"; "required": false; }; "hoverStateEnabled": { "alias": "hoverStateEnabled"; "required": false; }; "items": { "alias": "items"; "required": false; }; "itemTemplate": { "alias": "itemTemplate"; "required": false; }; "onContentReady": { "alias": "onContentReady"; "required": false; }; "onDisposing": { "alias": "onDisposing"; "required": false; }; "onInitialized": { "alias": "onInitialized"; "required": false; }; "onItemClick": { "alias": "onItemClick"; "required": false; }; "onItemCollapsed": { "alias": "onItemCollapsed"; "required": false; }; "onItemContextMenu": { "alias": "onItemContextMenu"; "required": false; }; "onItemExpanded": { "alias": "onItemExpanded"; "required": false; }; "onItemRendered": { "alias": "onItemRendered"; "required": false; }; "onOptionChanged": { "alias": "onOptionChanged"; "required": false; }; "onResize": { "alias": "onResize"; "required": false; }; "onResizeEnd": { "alias": "onResizeEnd"; "required": false; }; "onResizeStart": { "alias": "onResizeStart"; "required": false; }; "orientation": { "alias": "orientation"; "required": false; }; "rtlEnabled": { "alias": "rtlEnabled"; "required": false; }; "separatorSize": { "alias": "separatorSize"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; "width": { "alias": "width"; "required": false; }; }, { "itemsChange": "itemsChange"; }, ["itemsChildren"], never, false, never>;
}
export declare class DxoSplitterModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoSplitterModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoSplitterModule, [typeof DxoSplitterComponent], never, [typeof DxoSplitterComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoSplitterModule>;
}
