/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { HorizontalAlignment, VerticalAlignment } from 'devextreme/common';
import { Font } from 'devextreme/common/charts';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoStripStyleComponent extends NestedOption implements OnDestroy, OnInit {
    get label(): {
        font?: Font;
        horizontalAlignment?: HorizontalAlignment;
        verticalAlignment?: VerticalAlignment;
    } | {
        font?: Font;
    };
    set label(value: {
        font?: Font;
        horizontalAlignment?: HorizontalAlignment;
        verticalAlignment?: VerticalAlignment;
    } | {
        font?: Font;
    });
    get paddingLeftRight(): number;
    set paddingLeftRight(value: number);
    get paddingTopBottom(): number;
    set paddingTopBottom(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoStripStyleComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoStripStyleComponent, "dxo-strip-style", never, { "label": { "alias": "label"; "required": false; }; "paddingLeftRight": { "alias": "paddingLeftRight"; "required": false; }; "paddingTopBottom": { "alias": "paddingTopBottom"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoStripStyleModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoStripStyleModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoStripStyleModule, [typeof DxoStripStyleComponent], never, [typeof DxoStripStyleComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoStripStyleModule>;
}
