/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Store } from 'devextreme/data';
import DataSource, { Options as DataSourceOptions } from 'devextreme/data/data_source';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoTasksComponent extends NestedOption implements OnDestroy, OnInit {
    get colorExpr(): Function | string;
    set colorExpr(value: Function | string);
    get dataSource(): Store | DataSource | DataSourceOptions | null | string | Array<any>;
    set dataSource(value: Store | DataSource | DataSourceOptions | null | string | Array<any>);
    get endExpr(): Function | string;
    set endExpr(value: Function | string);
    get keyExpr(): Function | string;
    set keyExpr(value: Function | string);
    get parentIdExpr(): Function | string;
    set parentIdExpr(value: Function | string);
    get progressExpr(): Function | string;
    set progressExpr(value: Function | string);
    get startExpr(): Function | string;
    set startExpr(value: Function | string);
    get titleExpr(): Function | string;
    set titleExpr(value: Function | string);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTasksComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoTasksComponent, "dxo-tasks", never, { "colorExpr": { "alias": "colorExpr"; "required": false; }; "dataSource": { "alias": "dataSource"; "required": false; }; "endExpr": { "alias": "endExpr"; "required": false; }; "keyExpr": { "alias": "keyExpr"; "required": false; }; "parentIdExpr": { "alias": "parentIdExpr"; "required": false; }; "progressExpr": { "alias": "progressExpr"; "required": false; }; "startExpr": { "alias": "startExpr"; "required": false; }; "titleExpr": { "alias": "titleExpr"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoTasksModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTasksModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoTasksModule, [typeof DxoTasksComponent], never, [typeof DxoTasksComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoTasksModule>;
}
