/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { NestedOptionHost } from 'devextreme-angular/core';
import { DxoDataGridToolbar } from './base/data-grid-toolbar';
import { DxiItemComponent } from './item-dxi';
import { DxiFileSelectionItemComponent } from './file-selection-item-dxi';
import * as i0 from "@angular/core";
export declare class DxoToolbarComponent extends DxoDataGridToolbar implements OnDestroy, OnInit {
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiItemComponent>;
    set itemsChildren(value: QueryList<DxiItemComponent>);
    get fileSelectionItemsChildren(): QueryList<DxiFileSelectionItemComponent>;
    set fileSelectionItemsChildren(value: QueryList<DxiFileSelectionItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoToolbarComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoToolbarComponent, "dxo-toolbar", never, { "disabled": { "alias": "disabled"; "required": false; }; "items": { "alias": "items"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; "fileSelectionItems": { "alias": "fileSelectionItems"; "required": false; }; "container": { "alias": "container"; "required": false; }; "multiline": { "alias": "multiline"; "required": false; }; }, {}, ["itemsChildren", "fileSelectionItemsChildren"], never, false, never>;
}
export declare class DxoToolbarModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoToolbarModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoToolbarModule, [typeof DxoToolbarComponent], never, [typeof DxoToolbarComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoToolbarModule>;
}
