/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { PanelVisibility, ShapeCategory, ShapeType, ToolboxDisplayMode } from 'devextreme/ui/diagram';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiGroupComponent } from './group-dxi';
import * as i0 from "@angular/core";
export declare class DxoToolboxComponent extends NestedOption implements OnDestroy, OnInit {
    get groups(): Array<ShapeCategory | any | {
        category?: ShapeCategory | string;
        displayMode?: ToolboxDisplayMode;
        expanded?: boolean;
        shapes?: Array<ShapeType | string>;
        title?: string;
    }>;
    set groups(value: Array<ShapeCategory | any | {
        category?: ShapeCategory | string;
        displayMode?: ToolboxDisplayMode;
        expanded?: boolean;
        shapes?: Array<ShapeType | string>;
        title?: string;
    }>);
    get shapeIconsPerRow(): number;
    set shapeIconsPerRow(value: number);
    get showSearch(): boolean;
    set showSearch(value: boolean);
    get visibility(): PanelVisibility;
    set visibility(value: PanelVisibility);
    get width(): number | undefined;
    set width(value: number | undefined);
    protected get _optionPath(): string;
    get groupsChildren(): QueryList<DxiGroupComponent>;
    set groupsChildren(value: QueryList<DxiGroupComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoToolboxComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoToolboxComponent, "dxo-toolbox", never, { "groups": { "alias": "groups"; "required": false; }; "shapeIconsPerRow": { "alias": "shapeIconsPerRow"; "required": false; }; "showSearch": { "alias": "showSearch"; "required": false; }; "visibility": { "alias": "visibility"; "required": false; }; "width": { "alias": "width"; "required": false; }; }, {}, ["groupsChildren"], never, false, never>;
}
export declare class DxoToolboxModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoToolboxModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoToolboxModule, [typeof DxoToolboxComponent], never, [typeof DxoToolboxComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoToolboxModule>;
}
