/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { TooltipShowMode, VerticalEdge } from 'devextreme/common';
import { DashStyle, Font } from 'devextreme/common/charts';
import { Format } from 'devextreme/common/core/localization';
import { UserDefinedElement } from 'devextreme/core/element';
import { ChartTooltipLocation } from 'devextreme/viz/chart';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoTooltipComponent extends NestedOption implements OnDestroy, OnInit {
    get arrowLength(): number;
    set arrowLength(value: number);
    get border(): {
        color?: string;
        dashStyle?: DashStyle;
        opacity?: number | undefined;
        visible?: boolean;
        width?: number;
    };
    set border(value: {
        color?: string;
        dashStyle?: DashStyle;
        opacity?: number | undefined;
        visible?: boolean;
        width?: number;
    });
    get color(): string;
    set color(value: string);
    get container(): UserDefinedElement | string | undefined;
    set container(value: UserDefinedElement | string | undefined);
    get contentTemplate(): any | undefined;
    set contentTemplate(value: any | undefined);
    get cornerRadius(): number;
    set cornerRadius(value: number);
    get customizeTooltip(): Function | undefined;
    set customizeTooltip(value: Function | undefined);
    get enabled(): boolean;
    set enabled(value: boolean);
    get font(): Font;
    set font(value: Font);
    get format(): Format | string | undefined;
    set format(value: Format | string | undefined);
    get interactive(): boolean;
    set interactive(value: boolean);
    get opacity(): number | undefined;
    set opacity(value: number | undefined);
    get paddingLeftRight(): number;
    set paddingLeftRight(value: number);
    get paddingTopBottom(): number;
    set paddingTopBottom(value: number);
    get shadow(): {
        blur?: number;
        color?: string;
        offsetX?: number;
        offsetY?: number;
        opacity?: number;
    };
    set shadow(value: {
        blur?: number;
        color?: string;
        offsetX?: number;
        offsetY?: number;
        opacity?: number;
    });
    get zIndex(): number | undefined;
    set zIndex(value: number | undefined);
    get argumentFormat(): Format | string | undefined;
    set argumentFormat(value: Format | string | undefined);
    get location(): ChartTooltipLocation;
    set location(value: ChartTooltipLocation);
    get shared(): boolean;
    set shared(value: boolean);
    get isShown(): boolean;
    set isShown(value: boolean);
    get text(): string;
    set text(value: string);
    get position(): VerticalEdge;
    set position(value: VerticalEdge);
    get showMode(): TooltipShowMode;
    set showMode(value: TooltipShowMode);
    get customizeLinkTooltip(): Function | undefined;
    set customizeLinkTooltip(value: Function | undefined);
    get customizeNodeTooltip(): Function | undefined;
    set customizeNodeTooltip(value: Function | undefined);
    get linkTooltipTemplate(): any | undefined;
    set linkTooltipTemplate(value: any | undefined);
    get nodeTooltipTemplate(): any | undefined;
    set nodeTooltipTemplate(value: any | undefined);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTooltipComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoTooltipComponent, "dxo-tooltip", never, { "arrowLength": { "alias": "arrowLength"; "required": false; }; "border": { "alias": "border"; "required": false; }; "color": { "alias": "color"; "required": false; }; "container": { "alias": "container"; "required": false; }; "contentTemplate": { "alias": "contentTemplate"; "required": false; }; "cornerRadius": { "alias": "cornerRadius"; "required": false; }; "customizeTooltip": { "alias": "customizeTooltip"; "required": false; }; "enabled": { "alias": "enabled"; "required": false; }; "font": { "alias": "font"; "required": false; }; "format": { "alias": "format"; "required": false; }; "interactive": { "alias": "interactive"; "required": false; }; "opacity": { "alias": "opacity"; "required": false; }; "paddingLeftRight": { "alias": "paddingLeftRight"; "required": false; }; "paddingTopBottom": { "alias": "paddingTopBottom"; "required": false; }; "shadow": { "alias": "shadow"; "required": false; }; "zIndex": { "alias": "zIndex"; "required": false; }; "argumentFormat": { "alias": "argumentFormat"; "required": false; }; "location": { "alias": "location"; "required": false; }; "shared": { "alias": "shared"; "required": false; }; "isShown": { "alias": "isShown"; "required": false; }; "text": { "alias": "text"; "required": false; }; "position": { "alias": "position"; "required": false; }; "showMode": { "alias": "showMode"; "required": false; }; "customizeLinkTooltip": { "alias": "customizeLinkTooltip"; "required": false; }; "customizeNodeTooltip": { "alias": "customizeNodeTooltip"; "required": false; }; "linkTooltipTemplate": { "alias": "linkTooltipTemplate"; "required": false; }; "nodeTooltipTemplate": { "alias": "nodeTooltipTemplate"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoTooltipModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTooltipModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoTooltipModule, [typeof DxoTooltipComponent], never, [typeof DxoTooltipComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoTooltipModule>;
}
