/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { HeaderFilterSearchConfig } from 'devextreme/common/grids';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoPivotGridHeaderFilterComponent extends NestedOption implements OnDestroy, OnInit {
    get allowSearch(): boolean;
    set allowSearch(value: boolean);
    get allowSelectAll(): boolean;
    set allowSelectAll(value: boolean);
    get height(): number;
    set height(value: number);
    get search(): HeaderFilterSearchConfig;
    set search(value: HeaderFilterSearchConfig);
    get searchTimeout(): number;
    set searchTimeout(value: number);
    get showRelevantValues(): boolean;
    set showRelevantValues(value: boolean);
    get texts(): {
        cancel?: string;
        emptyValue?: string;
        ok?: string;
    };
    set texts(value: {
        cancel?: string;
        emptyValue?: string;
        ok?: string;
    });
    get width(): number;
    set width(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPivotGridHeaderFilterComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoPivotGridHeaderFilterComponent, "dxo-pivot-grid-header-filter", never, { "allowSearch": { "alias": "allowSearch"; "required": false; }; "allowSelectAll": { "alias": "allowSelectAll"; "required": false; }; "height": { "alias": "height"; "required": false; }; "search": { "alias": "search"; "required": false; }; "searchTimeout": { "alias": "searchTimeout"; "required": false; }; "showRelevantValues": { "alias": "showRelevantValues"; "required": false; }; "texts": { "alias": "texts"; "required": false; }; "width": { "alias": "width"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoPivotGridHeaderFilterModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPivotGridHeaderFilterModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoPivotGridHeaderFilterModule, [typeof DxoPivotGridHeaderFilterComponent], never, [typeof DxoPivotGridHeaderFilterComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoPivotGridHeaderFilterModule>;
}
