/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Font, LabelOverlap, DashStyle, RelativePosition } from 'devextreme/common/charts';
import { Format } from 'devextreme/common/core/localization';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoPolarChartLabelComponent extends NestedOption implements OnDestroy, OnInit {
    get font(): Font;
    set font(value: Font);
    get text(): string | undefined;
    set text(value: string | undefined);
    get visible(): boolean;
    set visible(value: boolean);
    get customizeHint(): ((argument: {
        value: Date | number | string;
        valueText: string;
    }) => string);
    set customizeHint(value: ((argument: {
        value: Date | number | string;
        valueText: string;
    }) => string));
    get customizeText(): ((argument: {
        value: Date | number | string;
        valueText: string;
    }) => string);
    set customizeText(value: ((argument: {
        value: Date | number | string;
        valueText: string;
    }) => string));
    get format(): Format | undefined;
    set format(value: Format | undefined);
    get indentFromAxis(): number;
    set indentFromAxis(value: number);
    get overlappingBehavior(): LabelOverlap;
    set overlappingBehavior(value: LabelOverlap);
    get argumentFormat(): Format | undefined;
    set argumentFormat(value: Format | undefined);
    get backgroundColor(): string | undefined;
    set backgroundColor(value: string | undefined);
    get border(): {
        color?: string | undefined;
        dashStyle?: DashStyle | undefined;
        visible?: boolean;
        width?: number;
    };
    set border(value: {
        color?: string | undefined;
        dashStyle?: DashStyle | undefined;
        visible?: boolean;
        width?: number;
    });
    get connector(): {
        color?: string | undefined;
        visible?: boolean;
        width?: number;
    };
    set connector(value: {
        color?: string | undefined;
        visible?: boolean;
        width?: number;
    });
    get displayFormat(): string | undefined;
    set displayFormat(value: string | undefined);
    get position(): RelativePosition;
    set position(value: RelativePosition);
    get rotationAngle(): number;
    set rotationAngle(value: number);
    get showForZeroValues(): boolean;
    set showForZeroValues(value: boolean);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPolarChartLabelComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoPolarChartLabelComponent, "dxo-polar-chart-label", never, { "font": { "alias": "font"; "required": false; }; "text": { "alias": "text"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; "customizeHint": { "alias": "customizeHint"; "required": false; }; "customizeText": { "alias": "customizeText"; "required": false; }; "format": { "alias": "format"; "required": false; }; "indentFromAxis": { "alias": "indentFromAxis"; "required": false; }; "overlappingBehavior": { "alias": "overlappingBehavior"; "required": false; }; "argumentFormat": { "alias": "argumentFormat"; "required": false; }; "backgroundColor": { "alias": "backgroundColor"; "required": false; }; "border": { "alias": "border"; "required": false; }; "connector": { "alias": "connector"; "required": false; }; "displayFormat": { "alias": "displayFormat"; "required": false; }; "position": { "alias": "position"; "required": false; }; "rotationAngle": { "alias": "rotationAngle"; "required": false; }; "showForZeroValues": { "alias": "showForZeroValues"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoPolarChartLabelModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPolarChartLabelModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoPolarChartLabelModule, [typeof DxoPolarChartLabelComponent], never, [typeof DxoPolarChartLabelComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoPolarChartLabelModule>;
}
