/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { ValueErrorBarDisplayMode, ValueErrorBarType } from 'devextreme/common/charts';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoPolarChartValueErrorBarComponent extends NestedOption implements OnDestroy, OnInit {
    get color(): string;
    set color(value: string);
    get displayMode(): ValueErrorBarDisplayMode;
    set displayMode(value: ValueErrorBarDisplayMode);
    get edgeLength(): number;
    set edgeLength(value: number);
    get highValueField(): string | undefined;
    set highValueField(value: string | undefined);
    get lineWidth(): number;
    set lineWidth(value: number);
    get lowValueField(): string | undefined;
    set lowValueField(value: string | undefined);
    get opacity(): number | undefined;
    set opacity(value: number | undefined);
    get type(): undefined | ValueErrorBarType;
    set type(value: undefined | ValueErrorBarType);
    get value(): number;
    set value(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPolarChartValueErrorBarComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoPolarChartValueErrorBarComponent, "dxo-polar-chart-value-error-bar", never, { "color": { "alias": "color"; "required": false; }; "displayMode": { "alias": "displayMode"; "required": false; }; "edgeLength": { "alias": "edgeLength"; "required": false; }; "highValueField": { "alias": "highValueField"; "required": false; }; "lineWidth": { "alias": "lineWidth"; "required": false; }; "lowValueField": { "alias": "lowValueField"; "required": false; }; "opacity": { "alias": "opacity"; "required": false; }; "type": { "alias": "type"; "required": false; }; "value": { "alias": "value"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoPolarChartValueErrorBarModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPolarChartValueErrorBarModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoPolarChartValueErrorBarModule, [typeof DxoPolarChartValueErrorBarComponent], never, [typeof DxoPolarChartValueErrorBarComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoPolarChartValueErrorBarModule>;
}
