/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, EventEmitter } from '@angular/core';
import { TimeInterval } from 'devextreme/common/charts';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoPolarChartWholeRangeComponent extends NestedOption implements OnDestroy, OnInit {
    get endValue(): Date | number | string | undefined;
    set endValue(value: Date | number | string | undefined);
    get length(): number | TimeInterval | undefined | {
        days?: number;
        hours?: number;
        milliseconds?: number;
        minutes?: number;
        months?: number;
        quarters?: number;
        seconds?: number;
        weeks?: number;
        years?: number;
    };
    set length(value: number | TimeInterval | undefined | {
        days?: number;
        hours?: number;
        milliseconds?: number;
        minutes?: number;
        months?: number;
        quarters?: number;
        seconds?: number;
        weeks?: number;
        years?: number;
    });
    get startValue(): Date | number | string | undefined;
    set startValue(value: Date | number | string | undefined);
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    endValueChange: EventEmitter<Date | number | string | undefined>;
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    startValueChange: EventEmitter<Date | number | string | undefined>;
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPolarChartWholeRangeComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoPolarChartWholeRangeComponent, "dxo-polar-chart-whole-range", never, { "endValue": { "alias": "endValue"; "required": false; }; "length": { "alias": "length"; "required": false; }; "startValue": { "alias": "startValue"; "required": false; }; }, { "endValueChange": "endValueChange"; "startValueChange": "startValueChange"; }, never, never, false, never>;
}
export declare class DxoPolarChartWholeRangeModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoPolarChartWholeRangeModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoPolarChartWholeRangeModule, [typeof DxoPolarChartWholeRangeComponent], never, [typeof DxoPolarChartWholeRangeComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoPolarChartWholeRangeModule>;
}
