/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { ApplicationRef, ComponentFactoryResolver, Injector, ComponentRef, Type, RendererFactory2 } from '@angular/core';
import { DxPopupComponent, DxPopupTypes } from '../component';
import * as i0 from "@angular/core";
export type DxPopupServiceComponent<T = any> = DxPopupComponent & {
    contentRef: ComponentRef<T>;
};
export declare class DxPopupService {
    private readonly injector;
    private readonly applicationRef;
    private readonly componentFactoryResolver;
    private readonly rendererFactory;
    constructor(injector: Injector, applicationRef: ApplicationRef, componentFactoryResolver: ComponentFactoryResolver, rendererFactory: RendererFactory2);
    open<T>(contentComponent: Type<T>, popupOptions?: DxPopupTypes.Properties): DxPopupServiceComponent<T>;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxPopupService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DxPopupService>;
}
