/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { ValueChangedCallMode } from 'devextreme/viz/range_selector';
import { SliderValueChangeMode } from 'devextreme/common';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoRangeSelectorBehaviorComponent extends NestedOption implements OnDestroy, OnInit {
    get allowSlidersSwap(): boolean;
    set allowSlidersSwap(value: boolean);
    get animationEnabled(): boolean;
    set animationEnabled(value: boolean);
    get callValueChanged(): ValueChangedCallMode;
    set callValueChanged(value: ValueChangedCallMode);
    get manualRangeSelectionEnabled(): boolean;
    set manualRangeSelectionEnabled(value: boolean);
    get moveSelectedRangeByClick(): boolean;
    set moveSelectedRangeByClick(value: boolean);
    get snapToTicks(): boolean;
    set snapToTicks(value: boolean);
    get valueChangeMode(): SliderValueChangeMode;
    set valueChangeMode(value: SliderValueChangeMode);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoRangeSelectorBehaviorComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoRangeSelectorBehaviorComponent, "dxo-range-selector-behavior", never, { "allowSlidersSwap": { "alias": "allowSlidersSwap"; "required": false; }; "animationEnabled": { "alias": "animationEnabled"; "required": false; }; "callValueChanged": { "alias": "callValueChanged"; "required": false; }; "manualRangeSelectionEnabled": { "alias": "manualRangeSelectionEnabled"; "required": false; }; "moveSelectedRangeByClick": { "alias": "moveSelectedRangeByClick"; "required": false; }; "snapToTicks": { "alias": "snapToTicks"; "required": false; }; "valueChangeMode": { "alias": "valueChangeMode"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoRangeSelectorBehaviorModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoRangeSelectorBehaviorModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoRangeSelectorBehaviorModule, [typeof DxoRangeSelectorBehaviorComponent], never, [typeof DxoRangeSelectorBehaviorComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoRangeSelectorBehaviorModule>;
}
