/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { BackgroundImageLocation } from 'devextreme/viz/range_selector';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoRangeSelectorImageComponent extends NestedOption implements OnDestroy, OnInit {
    get location(): BackgroundImageLocation;
    set location(value: BackgroundImageLocation);
    get url(): string | undefined | {
        rangeMaxPoint?: string | undefined;
        rangeMinPoint?: string | undefined;
    };
    set url(value: string | undefined | {
        rangeMaxPoint?: string | undefined;
        rangeMinPoint?: string | undefined;
    });
    get height(): number | {
        rangeMaxPoint?: number | undefined;
        rangeMinPoint?: number | undefined;
    };
    set height(value: number | {
        rangeMaxPoint?: number | undefined;
        rangeMinPoint?: number | undefined;
    });
    get width(): number | {
        rangeMaxPoint?: number | undefined;
        rangeMinPoint?: number | undefined;
    };
    set width(value: number | {
        rangeMaxPoint?: number | undefined;
        rangeMinPoint?: number | undefined;
    });
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoRangeSelectorImageComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoRangeSelectorImageComponent, "dxo-range-selector-image", never, { "location": { "alias": "location"; "required": false; }; "url": { "alias": "url"; "required": false; }; "height": { "alias": "height"; "required": false; }; "width": { "alias": "width"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoRangeSelectorImageModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoRangeSelectorImageModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoRangeSelectorImageModule, [typeof DxoRangeSelectorImageComponent], never, [typeof DxoRangeSelectorImageComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoRangeSelectorImageModule>;
}
