/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Font, LabelOverlap } from 'devextreme/common/charts';
import { Format } from 'devextreme/common/core/localization';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoRangeSelectorScaleLabelComponent extends NestedOption implements OnDestroy, OnInit {
    get customizeText(): ((scaleValue: {
        value: Date | number | string;
        valueText: string;
    }) => string);
    set customizeText(value: ((scaleValue: {
        value: Date | number | string;
        valueText: string;
    }) => string));
    get font(): Font;
    set font(value: Font);
    get format(): Format | undefined;
    set format(value: Format | undefined);
    get overlappingBehavior(): LabelOverlap;
    set overlappingBehavior(value: LabelOverlap);
    get topIndent(): number;
    set topIndent(value: number);
    get visible(): boolean;
    set visible(value: boolean);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoRangeSelectorScaleLabelComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoRangeSelectorScaleLabelComponent, "dxo-range-selector-scale-label", never, { "customizeText": { "alias": "customizeText"; "required": false; }; "font": { "alias": "font"; "required": false; }; "format": { "alias": "format"; "required": false; }; "overlappingBehavior": { "alias": "overlappingBehavior"; "required": false; }; "topIndent": { "alias": "topIndent"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoRangeSelectorScaleLabelModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoRangeSelectorScaleLabelModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoRangeSelectorScaleLabelModule, [typeof DxoRangeSelectorScaleLabelComponent], never, [typeof DxoRangeSelectorScaleLabelComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoRangeSelectorScaleLabelModule>;
}
