/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { ChartAxisScale } from 'devextreme/viz/range_selector';
import { ChartsDataType } from 'devextreme/common/charts';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoRangeSelectorValueAxisComponent extends NestedOption implements OnDestroy, OnInit {
    get inverted(): boolean;
    set inverted(value: boolean);
    get logarithmBase(): number;
    set logarithmBase(value: number);
    get max(): number | undefined;
    set max(value: number | undefined);
    get min(): number | undefined;
    set min(value: number | undefined);
    get type(): ChartAxisScale | undefined;
    set type(value: ChartAxisScale | undefined);
    get valueType(): ChartsDataType | undefined;
    set valueType(value: ChartsDataType | undefined);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoRangeSelectorValueAxisComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoRangeSelectorValueAxisComponent, "dxo-range-selector-value-axis", never, { "inverted": { "alias": "inverted"; "required": false; }; "logarithmBase": { "alias": "logarithmBase"; "required": false; }; "max": { "alias": "max"; "required": false; }; "min": { "alias": "min"; "required": false; }; "type": { "alias": "type"; "required": false; }; "valueType": { "alias": "valueType"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoRangeSelectorValueAxisModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoRangeSelectorValueAxisModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoRangeSelectorValueAxisModule, [typeof DxoRangeSelectorValueAxisComponent], never, [typeof DxoRangeSelectorValueAxisComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoRangeSelectorValueAxisModule>;
}
