/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { SankeyColorMode } from 'devextreme/viz/sankey';
import { HatchDirection } from 'devextreme/common/charts';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoSankeyLinkComponent extends NestedOption implements OnDestroy, OnInit {
    get border(): {
        color?: string | undefined;
        visible?: boolean | undefined;
        width?: number | undefined;
    };
    set border(value: {
        color?: string | undefined;
        visible?: boolean | undefined;
        width?: number | undefined;
    });
    get color(): string;
    set color(value: string);
    get colorMode(): SankeyColorMode;
    set colorMode(value: SankeyColorMode);
    get hoverStyle(): {
        border?: {
            color?: string | undefined;
            visible?: boolean | undefined;
            width?: number | undefined;
        };
        color?: string | undefined;
        hatching?: {
            direction?: HatchDirection;
            opacity?: number;
            step?: number;
            width?: number;
        };
        opacity?: number | undefined;
    };
    set hoverStyle(value: {
        border?: {
            color?: string | undefined;
            visible?: boolean | undefined;
            width?: number | undefined;
        };
        color?: string | undefined;
        hatching?: {
            direction?: HatchDirection;
            opacity?: number;
            step?: number;
            width?: number;
        };
        opacity?: number | undefined;
    });
    get opacity(): number;
    set opacity(value: number);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoSankeyLinkComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoSankeyLinkComponent, "dxo-sankey-link", never, { "border": { "alias": "border"; "required": false; }; "color": { "alias": "color"; "required": false; }; "colorMode": { "alias": "colorMode"; "required": false; }; "hoverStyle": { "alias": "hoverStyle"; "required": false; }; "opacity": { "alias": "opacity"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoSankeyLinkModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoSankeyLinkModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoSankeyLinkModule, [typeof DxoSankeyLinkComponent], never, [typeof DxoSankeyLinkComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoSankeyLinkModule>;
}
