/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, EventEmitter } from '@angular/core';
import { GridBase } from 'devextreme/common/grids';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoTreeListFilterPanelComponent extends NestedOption implements OnDestroy, OnInit {
    get customizeText(): ((e: {
        component: GridBase;
        filterValue: Record<string, any>;
        text: string;
    }) => string);
    set customizeText(value: ((e: {
        component: GridBase;
        filterValue: Record<string, any>;
        text: string;
    }) => string));
    get filterEnabled(): boolean;
    set filterEnabled(value: boolean);
    get texts(): {
        clearFilter?: string;
        createFilter?: string;
        filterEnabledHint?: string;
    };
    set texts(value: {
        clearFilter?: string;
        createFilter?: string;
        filterEnabledHint?: string;
    });
    get visible(): boolean;
    set visible(value: boolean);
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    filterEnabledChange: EventEmitter<boolean>;
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTreeListFilterPanelComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoTreeListFilterPanelComponent, "dxo-tree-list-filter-panel", never, { "customizeText": { "alias": "customizeText"; "required": false; }; "filterEnabled": { "alias": "filterEnabled"; "required": false; }; "texts": { "alias": "texts"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; }, { "filterEnabledChange": "filterEnabledChange"; }, never, never, false, never>;
}
export declare class DxoTreeListFilterPanelModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTreeListFilterPanelModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoTreeListFilterPanelModule, [typeof DxoTreeListFilterPanelComponent], never, [typeof DxoTreeListFilterPanelComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoTreeListFilterPanelModule>;
}
