/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, ElementRef, Renderer2, AfterViewInit, QueryList } from '@angular/core';
import * as CommonTypes from 'devextreme/common';
import { FormItemComponent, FormItemType, LabelLocation } from 'devextreme/ui/form';
import { HorizontalAlignment } from 'devextreme/common';
import { NestedOptionHost, DxTemplateDirective, IDxTemplateHost, DxTemplateHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiTreeListAsyncRuleComponent } from './async-rule-dxi';
import { DxiTreeListCompareRuleComponent } from './compare-rule-dxi';
import { DxiTreeListCustomRuleComponent } from './custom-rule-dxi';
import { DxiTreeListEmailRuleComponent } from './email-rule-dxi';
import { DxiTreeListNumericRuleComponent } from './numeric-rule-dxi';
import { DxiTreeListPatternRuleComponent } from './pattern-rule-dxi';
import { DxiTreeListRangeRuleComponent } from './range-rule-dxi';
import { DxiTreeListRequiredRuleComponent } from './required-rule-dxi';
import { DxiTreeListStringLengthRuleComponent } from './string-length-rule-dxi';
import { DxiTreeListValidationRuleComponent } from './validation-rule-dxi';
import * as i0 from "@angular/core";
export declare class DxoTreeListFormItemComponent extends NestedOption implements AfterViewInit, OnDestroy, OnInit, IDxTemplateHost {
    private renderer;
    private document;
    private element;
    get colSpan(): number | undefined;
    set colSpan(value: number | undefined);
    get cssClass(): string | undefined;
    set cssClass(value: string | undefined);
    get dataField(): string | undefined;
    set dataField(value: string | undefined);
    get editorOptions(): any | undefined;
    set editorOptions(value: any | undefined);
    get editorType(): FormItemComponent;
    set editorType(value: FormItemComponent);
    get helpText(): string | undefined;
    set helpText(value: string | undefined);
    get isRequired(): boolean | undefined;
    set isRequired(value: boolean | undefined);
    get itemType(): FormItemType;
    set itemType(value: FormItemType);
    get label(): {
        alignment?: HorizontalAlignment;
        location?: LabelLocation;
        showColon?: boolean;
        template?: any;
        text?: string | undefined;
        visible?: boolean;
    };
    set label(value: {
        alignment?: HorizontalAlignment;
        location?: LabelLocation;
        showColon?: boolean;
        template?: any;
        text?: string | undefined;
        visible?: boolean;
    });
    get name(): string | undefined;
    set name(value: string | undefined);
    get template(): any;
    set template(value: any);
    get validationRules(): Array<CommonTypes.ValidationRule>;
    set validationRules(value: Array<CommonTypes.ValidationRule>);
    get visible(): boolean;
    set visible(value: boolean);
    get visibleIndex(): number | undefined;
    set visibleIndex(value: number | undefined);
    protected get _optionPath(): string;
    get asyncRulesChildren(): QueryList<DxiTreeListAsyncRuleComponent>;
    set asyncRulesChildren(value: QueryList<DxiTreeListAsyncRuleComponent>);
    get compareRulesChildren(): QueryList<DxiTreeListCompareRuleComponent>;
    set compareRulesChildren(value: QueryList<DxiTreeListCompareRuleComponent>);
    get customRulesChildren(): QueryList<DxiTreeListCustomRuleComponent>;
    set customRulesChildren(value: QueryList<DxiTreeListCustomRuleComponent>);
    get emailRulesChildren(): QueryList<DxiTreeListEmailRuleComponent>;
    set emailRulesChildren(value: QueryList<DxiTreeListEmailRuleComponent>);
    get numericRulesChildren(): QueryList<DxiTreeListNumericRuleComponent>;
    set numericRulesChildren(value: QueryList<DxiTreeListNumericRuleComponent>);
    get patternRulesChildren(): QueryList<DxiTreeListPatternRuleComponent>;
    set patternRulesChildren(value: QueryList<DxiTreeListPatternRuleComponent>);
    get rangeRulesChildren(): QueryList<DxiTreeListRangeRuleComponent>;
    set rangeRulesChildren(value: QueryList<DxiTreeListRangeRuleComponent>);
    get requiredRulesChildren(): QueryList<DxiTreeListRequiredRuleComponent>;
    set requiredRulesChildren(value: QueryList<DxiTreeListRequiredRuleComponent>);
    get stringLengthRulesChildren(): QueryList<DxiTreeListStringLengthRuleComponent>;
    set stringLengthRulesChildren(value: QueryList<DxiTreeListStringLengthRuleComponent>);
    get validationRulesChildren(): QueryList<DxiTreeListValidationRuleComponent>;
    set validationRulesChildren(value: QueryList<DxiTreeListValidationRuleComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost, renderer: Renderer2, document: any, templateHost: DxTemplateHost, element: ElementRef);
    setTemplate(template: DxTemplateDirective): void;
    ngAfterViewInit(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTreeListFormItemComponent, [{ host: true; skipSelf: true; }, { host: true; }, null, null, { host: true; }, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoTreeListFormItemComponent, "dxo-tree-list-form-item", never, { "colSpan": { "alias": "colSpan"; "required": false; }; "cssClass": { "alias": "cssClass"; "required": false; }; "dataField": { "alias": "dataField"; "required": false; }; "editorOptions": { "alias": "editorOptions"; "required": false; }; "editorType": { "alias": "editorType"; "required": false; }; "helpText": { "alias": "helpText"; "required": false; }; "isRequired": { "alias": "isRequired"; "required": false; }; "itemType": { "alias": "itemType"; "required": false; }; "label": { "alias": "label"; "required": false; }; "name": { "alias": "name"; "required": false; }; "template": { "alias": "template"; "required": false; }; "validationRules": { "alias": "validationRules"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; "visibleIndex": { "alias": "visibleIndex"; "required": false; }; }, {}, ["asyncRulesChildren", "compareRulesChildren", "customRulesChildren", "emailRulesChildren", "numericRulesChildren", "patternRulesChildren", "rangeRulesChildren", "requiredRulesChildren", "stringLengthRulesChildren", "validationRulesChildren"], ["*"], false, never>;
}
export declare class DxoTreeListFormItemModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTreeListFormItemModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoTreeListFormItemModule, [typeof DxoTreeListFormItemComponent], never, [typeof DxoTreeListFormItemComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoTreeListFormItemModule>;
}
