/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, QueryList } from '@angular/core';
import { dxTreeListToolbarItem, TreeListPredefinedToolbarItem } from 'devextreme/ui/tree_list';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import { DxiTreeListItemComponent } from './item-dxi';
import * as i0 from "@angular/core";
export declare class DxoTreeListToolbarComponent extends NestedOption implements OnDestroy, OnInit {
    get disabled(): boolean;
    set disabled(value: boolean);
    get items(): Array<dxTreeListToolbarItem | TreeListPredefinedToolbarItem>;
    set items(value: Array<dxTreeListToolbarItem | TreeListPredefinedToolbarItem>);
    get visible(): boolean | undefined;
    set visible(value: boolean | undefined);
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiTreeListItemComponent>;
    set itemsChildren(value: QueryList<DxiTreeListItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTreeListToolbarComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoTreeListToolbarComponent, "dxo-tree-list-toolbar", never, { "disabled": { "alias": "disabled"; "required": false; }; "items": { "alias": "items"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; }, {}, ["itemsChildren"], never, false, never>;
}
export declare class DxoTreeListToolbarModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTreeListToolbarModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoTreeListToolbarModule, [typeof DxoTreeListToolbarComponent], never, [typeof DxoTreeListToolbarComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoTreeListToolbarModule>;
}
