/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Palette, PaletteExtensionMode } from 'devextreme/common/charts';
import { TreeMapColorizerType } from 'devextreme/viz/tree_map';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoTreeMapColorizerComponent extends NestedOption implements OnDestroy, OnInit {
    get colorCodeField(): string | undefined;
    set colorCodeField(value: string | undefined);
    get colorizeGroups(): boolean;
    set colorizeGroups(value: boolean);
    get palette(): Array<string> | Palette;
    set palette(value: Array<string> | Palette);
    get paletteExtensionMode(): PaletteExtensionMode;
    set paletteExtensionMode(value: PaletteExtensionMode);
    get range(): Array<number>;
    set range(value: Array<number>);
    get type(): TreeMapColorizerType | undefined;
    set type(value: TreeMapColorizerType | undefined);
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTreeMapColorizerComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoTreeMapColorizerComponent, "dxo-tree-map-colorizer", never, { "colorCodeField": { "alias": "colorCodeField"; "required": false; }; "colorizeGroups": { "alias": "colorizeGroups"; "required": false; }; "palette": { "alias": "palette"; "required": false; }; "paletteExtensionMode": { "alias": "paletteExtensionMode"; "required": false; }; "range": { "alias": "range"; "required": false; }; "type": { "alias": "type"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoTreeMapColorizerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTreeMapColorizerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoTreeMapColorizerModule, [typeof DxoTreeMapColorizerComponent], never, [typeof DxoTreeMapColorizerComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoTreeMapColorizerModule>;
}
