/*!
 * devextreme-angular
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy } from '@angular/core';
import { Font, TextOverflow, WordWrap } from 'devextreme/common/charts';
import { NestedOptionHost } from 'devextreme-angular/core';
import { NestedOption } from 'devextreme-angular/core';
import * as i0 from "@angular/core";
export declare class DxoTreeMapTileComponent extends NestedOption implements OnDestroy, OnInit {
    get border(): {
        color?: string | undefined;
        width?: number | undefined;
    };
    set border(value: {
        color?: string | undefined;
        width?: number | undefined;
    });
    get color(): string;
    set color(value: string);
    get hoverStyle(): {
        border?: {
            color?: string | undefined;
            width?: number | undefined;
        };
        color?: string | undefined;
    };
    set hoverStyle(value: {
        border?: {
            color?: string | undefined;
            width?: number | undefined;
        };
        color?: string | undefined;
    });
    get label(): {
        font?: Font;
        textOverflow?: TextOverflow;
        visible?: boolean;
        wordWrap?: WordWrap;
    };
    set label(value: {
        font?: Font;
        textOverflow?: TextOverflow;
        visible?: boolean;
        wordWrap?: WordWrap;
    });
    get selectionStyle(): {
        border?: {
            color?: string | undefined;
            width?: number | undefined;
        };
        color?: string | undefined;
    };
    set selectionStyle(value: {
        border?: {
            color?: string | undefined;
            width?: number | undefined;
        };
        color?: string | undefined;
    });
    protected get _optionPath(): string;
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTreeMapTileComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoTreeMapTileComponent, "dxo-tree-map-tile", never, { "border": { "alias": "border"; "required": false; }; "color": { "alias": "color"; "required": false; }; "hoverStyle": { "alias": "hoverStyle"; "required": false; }; "label": { "alias": "label"; "required": false; }; "selectionStyle": { "alias": "selectionStyle"; "required": false; }; }, {}, never, never, false, never>;
}
export declare class DxoTreeMapTileModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoTreeMapTileModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoTreeMapTileModule, [typeof DxoTreeMapTileComponent], never, [typeof DxoTreeMapTileComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoTreeMapTileModule>;
}
